// ---------------------------------------New stuff


// My functions

void scrying(int p, int c, int number){
  int *deck = deck_ptr[p];
  int deck_size = count_deck(p);
  int remaining = number;
  int selected = 0;
  if( deck_size < number ){
      remaining = deck_size;
  }
  if( deck_size > 0 ){
     if( p == HUMAN ){
        while( remaining > 0){

              selected = -1;
              while( selected == -1 ){
                    selected = show_deck( p, deck_ptr[p], remaining, "Pick a card", 0, 0x7375B0 );
              
              }

              int choice = do_dialog(p, p, c, -1, -1, " Put on top\n Put on bottom", 1);
              if(choice == 0 && remaining > 1){
                 deck[ remaining ] = deck[selected];               
                 remove_card_from_deck( p, selected );
                 choice = -1;
              }

              if(choice == 1){
                 deck[ count_deck(p) ] = deck[selected];               
                 remove_card_from_deck( p, selected );
                 choice = -1;
              }
              remaining--;
        }
     }
     else{
          while( remaining > 1 ){
                remaining--;
                deck[ count_deck(p) ] = deck[0];
                remove_card_from_deck( p, 0 );    
          }
    }
  }
}


void rearrange_top_x(int p, int p1, int number){
  int *deck = deck_ptr[p];
  int deck_size = count_deck(p);
  int remaining = number;
  int selected = 0;
  if( deck_size < number ){
      remaining = deck_size;
  }
  if( deck_size > 0 ){
        while( remaining > 0){

              selected = -1;
              while( selected == -1 ){
                    selected = show_deck( p1, deck_ptr[p], remaining, "Pick a card to put on top", 0, 0x7375B0 );
              
              }
              if( remaining > 1 ){
                 deck[ remaining ] = deck[selected];               
                 remove_card_from_deck( p, selected );
              }
              remaining--;
        }
  }
}

int ai_best_reanimator_target(int player, int selected_type){
  int *graveyard = graveyard_ptr[player];
  int max_cmc = -1;
  int max_index = -1;
  int i;
  if( count_graveyard_by_type(player, selected_type) > 0 ){
     for(i = 0; i < count_graveyard(player); i++){
         if( (graveyard[i] != -1) && (cards_data[  graveyard[i] ].type & selected_type) ){
            int cmc = cards_data[  graveyard[i] ].cc[0] + cards_data[  graveyard[i] ].cc[1];
            if( cmc > max_cmc ){
               max_cmc = cmc;
               max_index = i;
            } 
         } 
     }
  } 

  return max_index; 
} 

int select_target_from_graveyard(int player, int type, int whose_grave){
    int selected = -1;
    while(1){
        selected = show_deck( player, graveyard_ptr[whose_grave], 500, "Pick a card to reanimate", 0, 0x7375B0 );
        if( selected != -1){
            int *grave = graveyard_ptr[whose_grave];
            if ( cards_data[ grave[selected] ].type & type ){
                return selected;
            }
        }
        else{
            break;
        }      
    }
    return selected;
}

void reanimate_permanent(int p, int c, int target_graveyard, int selected, int action, int override){
  if( selected > 0){
     int *grave = graveyard_ptr[target_graveyard];
     int card_added =  add_card_to_hand(target_graveyard, grave[selected] );
     if(override < 1){     
        remove_card_from_grave(target_graveyard, selected);
     }
     put_into_play( target_graveyard, card_added );
     if( action == 1){
        tap_card(target_graveyard, card_added);
     }
     if( p != target_graveyard ){
        gain_control(p, c, target_graveyard, card_added);
     }
  }
}

void manipulate_all(int p, int type, int flag1, int subtype, int flag2, int color, int flag3, int id, int flag4, int cc, int flag5, int action){

// type, subtype, color and id are considered only if are > 0, instead cc is considere only if is > -1
// otherwise, flag determinates inclusive or exclusive test about that particular argument
// 0 = inclusive
// 1 = exclusive
// example : manipulate_all(player, TYPE_LAND, 0, SUBTIPE_ISLAND, 0, 0, 0, 0, 0, -1, 0, 5)
//           will bounce all the land permanents Player controls with subtype island 
// otherwise : manipulate_all(player, TYPE_LAND, 0, SUBTIPE_ISLAND, 1, 0, 0, 0, 0, -1, 0, 5)
//             will bounce all the land permanents Player controls that haven't the subtype island
//
// type of "action"
// 1 = KILL_DESTROY
// 2 = KILL_BURY
// 3 = KILL_SACRIFICE
// 4 = KILL_REMOVE
// 5 = bounce
// 6 = tap
// 7 = untap
// 8 = add_1_1_counter
// 9 = remove_counter
// 10 = set_counters to 0

  int TEST_TYPE = 0;
  
  if( (type) && flag1 < 1){
     TEST_TYPE+=1;
  }

  if( (subtype) && flag2 < 1){
     TEST_TYPE+=2;
  }

  if( (color) && flag3 < 1){
     TEST_TYPE+=4;
  }

  if( (id) && flag4 < 1){
     TEST_TYPE+=8;
  }

  if( cc > -1 && flag5 < 1){
     TEST_TYPE+=16;
  }

  if( (type) && flag1 > 0){
     TEST_TYPE+=32;
  }

  if( (subtype) && flag2 > 0){
     TEST_TYPE+=64;
  }

  if( (color) && flag3 > 0){
     TEST_TYPE+=128;
  }

  if( (id) && flag4 > 0){
     TEST_TYPE+=256;
  }

  if( cc > -1 && flag5 > 0){
     TEST_TYPE+=512;
  }

  int count = active_cards_count[p]-1;
  while( count > -1 ){
        int test = 0;
        card_data_t card_d = get_card_data(p, count);
        if( (card_d.type & TYPE_PERMANENT) && in_play(p, count) ){

           if( type > 0 && (card_d.type & type) ){
              test+=1;
           }

           if( subtype > 0 && (has_subtype(p, count, subtype)) ){
              test+=2;
           }

           if( color > 0 && (get_color(p, count) & color) ){
              test+=4;
           }

           if( id > 0 && card_d.id == id ){
              test+=8;
           }

           if( cc > -1 && get_cmc(p, count) == cc ){
              test+=16;
           }

           if( type > 0 && flag1 > 0 && !(card_d.type & type) ){
              test+=32;
           }

           if( subtype > 0 && flag2 > 0 && !(has_subtype(p, count, subtype)) ){
              test+=64;
           }

           if( color > 0 && flag3 > 0 && !(get_color(p, count) & color) ){
              test+=128;
           }

           if( id > 0 && flag4 > 0 && !(card_d.id == id) ){
              test+=256;
           }

           if( cc > -1 && flag5 > 0 && !(get_cmc(p, count) == cc) ){
              test+=512;
           }

           if( test == TEST_TYPE ){

              if( action == 1){
                 kill_card(p, count, KILL_DESTROY);
              }

              if( action == 2){
                 kill_card(p, count, KILL_BURY);
              }
 
              if( action == 3){
                 kill_card(p, count, KILL_SACRIFICE);
              }

              if( action == 4){
                 kill_card(p, count, KILL_REMOVE);
              }

              if( action == 5){
                 bounce_permanent(p, count);
              }

              if( action == 6){
                 tap_card(p, count);
              }

              if( action == 7){
                 untap_card(p, count);
              }

              if( action == 8){
                 add_1_1_counter(p, count);
              }

              if( action == 9){
                 remove_counter(p, count);
              }

              if( action == 10){
                 set_counters(p, count, 0);
              }


           }
        }
        count--;
  }
}

void gating(int p, int c, event_t e){

 if( comes_into_play(p, c, e) == 1){
   int clr = get_color(p, c);
   int ncolor = 0;
   char buffer[500];
   sprintf(buffer, "Select a " );

   if( clr & COLOR_TEST_BLACK){
      ncolor++;
   }

   if( clr & COLOR_TEST_BLUE){
      ncolor++;
   }

   if( clr & COLOR_TEST_GREEN){
      ncolor++;
   }

   if( clr & COLOR_TEST_RED){
      ncolor++;
   }

   if( clr & COLOR_TEST_WHITE){
      ncolor++;
   }

   if( clr & COLOR_TEST_BLACK){
      sprintf(buffer, "%sblack", buffer ); 
      if(ncolor > 2){
         sprintf(buffer, "%s, ", buffer ); 
      }
      if(ncolor > 1){
         sprintf(buffer, "%s or ", buffer ); 
      }
      ncolor--;
   }

   if( clr & COLOR_TEST_BLUE){
      sprintf(buffer, "%sblue", buffer); 
      if(ncolor > 2){
         sprintf(buffer, "%s, ", buffer ); 
      }
      if(ncolor > 1){
         sprintf(buffer, "%s or ", buffer ); 
      }
      ncolor--;
   }

   if( clr & COLOR_TEST_GREEN){
      sprintf(buffer, "%sgreen", buffer ); 
      if(ncolor > 2){
         sprintf(buffer, "%s, ", buffer ); 
      }
      if(ncolor > 1){
         sprintf(buffer, "%s or ", buffer ); 
      }
      ncolor--;
   }

   if( clr & COLOR_TEST_RED){
      sprintf(buffer, "%sred", buffer ); 
      if(ncolor > 2){
         sprintf(buffer, "%s ", buffer ); 
      }
      if(ncolor > 1){
         sprintf(buffer, "%s or ", buffer ); 
      }
   }

   if( clr & COLOR_TEST_WHITE){
      sprintf(buffer, "%swhite", buffer ); 
   }
   sprintf(buffer, "%s creature you control", buffer );
   target_definition_t td;
   default_target_definition(p, c, &td, TYPE_CREATURE);
   td.allowed_controller = p;
   td.preferred_controller = p;
   td.allow_cancel = 0;
   td.illegal_abilities = 0;
   select_target(p, c, &td, buffer, NULL);
   card_instance_t *instance = get_card_instance(p, c);
   int clr2 = get_color(instance->targets[0].player, instance->targets[0].card);
   if ( !(clr2 & clr) ){
       instance->targets[0].player = p;
       instance->targets[0].card = c;
   }
   if( validate_target(p, c, &td, 0) ){
      bounce_permanent(instance->targets[0].player, instance->targets[0].card);
      instance->number_of_targets = 0;
   }
  }
}

int specific_gfp(int player, int card, event_t event, int selected_type, int flag){

  if( event == EVENT_GRAVEYARD_FROM_PLAY){
     if( flag == 1){
        if( !(affect_me(player, card)) ){
           if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
           card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
           if( affected->kill_code != 4) {
              if( cards_data[ affected->internal_card_id ].type & selected_type ){
                 return 1;
              }
           }
        }
     }
     else{
          if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
          card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
          if( affected->kill_code != 4) {
             if( cards_data[ affected->internal_card_id ].type & selected_type ){
                return 1;
             }
          }
     }
  }

  return 0;
}

int remove_1_1_counter(int player, int card){
  card_instance_t *instance = get_card_instance(player, card);
  if( instance->counters > 0){
     instance->counters--;
     instance->counter_power--;
     instance->counter_toughness--;
  }
  return instance->counters;
}

// New cards

int krovikan_horror(int player, int card, event_t event){
  int cnt = count_graveyard_by_id(player, 753);

  if( trigger_condition == TRIGGER_EOT && affect_me(player, card) && cnt > 0){
     if(event == EVENT_TRIGGER){
        event_result |= RESOLVE_TRIGGER_MANDATORY;
     }
     else if(event == EVENT_RESOLVE_TRIGGER){
        int *graveyard = graveyard_ptr[player];
        int count = count_graveyard(player)-1;
        int activate = -1;
        int horrors = 0;
        int position[3];
        while( count > -1){
              if( cards_data[  graveyard[count] ].id == 753 ){
                 position[horrors] = count;
                 horrors++;
              }
              count--;
        }

        if( horrors == 1 && (cards_data[ graveyard[position[0]+1] ].type & TYPE_CREATURE) ){
           activate = position[0];
        }
        else if(horrors > 1){
                int k;
                for(k = 0; k < horrors; k++){
                    if( cards_data[ graveyard[position[k]+1] ].type & TYPE_CREATURE){
                       activate = position[k];
                    }
                }
        }
  
        if( activate > -1 ){          
           int choice = do_dialog(player, player, card, -1, -1," Return Krovikan Horror\n Do not return Krovikan Horror\n", 0);
           if( choice == 0 ){
              add_card_to_hand(player, graveyard[activate]);   
              remove_card_from_grave(player, activate);
           }
        }
     }
   }
  return 0;
}

int card_krovikan_horror(int player, int card, event_t event){
  target_definition_t td;
  default_target_definition(player, card, &td, TYPE_CREATURE);
  td.allowed_controller = player;
  td.preferred_controller = player;
  td.who_chooses = player;
  td.allow_cancel = 0;
  card_instance_t *instance = get_card_instance(player, card);


  if( event == EVENT_CAN_ACTIVATE && affect_me(player, card) ){
     if( has_mana_multi(player, 1, 0, 0, 0, 0, 0)  && target_available(player, card, &td) > 0){
        return 1;
     }
  }

  else if( event == EVENT_ACTIVATE && affect_me(player, card)){
          charge_mana_multi(player, 1, 0, 0, 0, 0, 0);
          if(spell_fizzled != 1){
             pick_target(&td, "LORD_OF_THE_PIT");
             if( valid_target(&td) ){ 
                kill_card(instance->targets[0].player, instance->targets[0].card, KILL_BURY);
                instance->number_of_targets = 1;
                target_definition_t td1;
                default_target_definition(player, card, &td1, TYPE_CREATURE );
                td1.zone = TARGET_ZONE_CREATURE_OR_PLAYER;
                td1.allow_cancel = 0;
                pick_target(&td1, "PSIONIC_BLAST");
                instance->number_of_targets = 1;
                if( valid_target(&td1) ){ 
                   instance->targets[1].player = instance->targets[0].player;
                   instance->targets[1].card = instance->targets[0].card;
                   instance->info_slot = 66;
                }
             }
          }
  }

  else if( event == EVENT_RESOLVE_ACTIVATION && affect_me(player, card) && instance->info_slot == 66){
          damage_creature_or_player(player, card, event, 1, 3);
  }
 
  return 0;
}


