#include "manalink.h"

int has_creature_type(int player, int card, subtype_t subtype)
{
  card_instance_t* instance = get_card_instance(player, card);
  int id = instance->internal_card_id;
  card_data_t card_d = cards_data[id];
  card_ptr_t* c = cards_ptr[card_d.id];
  if(card_d.type & TYPE_CREATURE && (c->subtype1 == subtype || c->subtype2 == subtype)){
    return 1;
  }
  return 0;
}

int has_subtype(int player, int card, subtype_t subtype){
  card_instance_t* instance = get_card_instance(player, card);
  int id = instance->internal_card_id;
  card_data_t card_d = cards_data[id];
  card_ptr_t* c = cards_ptr[card_d.id];
  if( c->subtype1 == subtype || c->subtype2 == subtype ){
    return 1;
  }
  return 0;
}

