#ifndef SUBTYPES_H
#define SUBTYPES_H

typedef enum
{
  SUBTYPE_INCARNATION       =   1,
  SUBTYPE_ARTIFICER         =   2,
  SUBTYPE_ADVISOR           =   3,
  SUBTYPE_PEST              =   4,
  SUBTYPE_ANGEL             =   5,
  SUBTYPE_ANTEATER          =   6,
  SUBTYPE_APE               =   7,
  SUBTYPE_NIGHTSTALKER      =   8,
  SUBTYPE_ARCHER            =   9,
  SUBTYPE_DRYAD             =  10,
  SUBTYPE_ARTIFACT          =  11,
  SUBTYPE_ANTELOPE          =  12,
  SUBTYPE_ASSASSIN          =  13,
  SUBTYPE_ATOG              =  14,
  SUBTYPE_AVATAR            =  15,
  SUBTYPE_ARCHON            =  16,
  SUBTYPE_PLANT             =  17,
  SUBTYPE_BADGER            =  18,
  SUBTYPE_AUROCHS           =  19,
  SUBTYPE_BEEBLE            =  20,
  SUBTYPE_BLINKMOTH         =  21,
  SUBTYPE_BASILISK          =  22,
  SUBTYPE_BAT               =  23,
  SUBTYPE_BEAR              =  24,
  SUBTYPE_BEAST             =  25,
  SUBTYPE_BRINGER           =  26,
  SUBTYPE_SLIVER            =  27,
  SUBTYPE_BERSERKER         =  28,
  SUBTYPE_MONK              =  29,
  SUBTYPE_BOAR              =  30,
  SUBTYPE_TRAP         =  31,
  SUBTYPE_ALLY              =  32,
  SUBTYPE_OX                =  33,
  SUBTYPE_CYCLOPS           =  34,
  SUBTYPE_CAMEL             =  35,
  SUBTYPE_EQUIPMENT           =  36,
  SUBTYPE_CEPHALID          =  37,
  SUBTYPE_CHIMERA           =  38,
  SUBTYPE_CENTAUR           =  39,
  SUBTYPE_CLERIC            =  40,
  SUBTYPE_SHAPESHIFTER      =  41,
  SUBTYPE_CONSTRUCT         =  42,
  SUBTYPE_COCKATRICE        =  43,
  SUBTYPE_ARTIFACT_CREATURE =  44,
  SUBTYPE_CITIZEN           =  45,
  SUBTYPE_DEMON             =  46,
  SUBTYPE_ELDRAZI            =  47,
  SUBTYPE_DEVIL             =  48,
  SUBTYPE_CRAB              =  49,
  SUBTYPE_DJINN             =  50,
  SUBTYPE_SHAMAN            =  51,
  SUBTYPE_DRAGON            =  52,
  SUBTYPE_DAUTHI            =  53,
  SUBTYPE_DRAKE             =  54,
  SUBTYPE_DESERTER          =  55,
  SUBTYPE_DRUID             =  56,
  SUBTYPE_DWARF             =  57,
  SUBTYPE_EYE               =  58,
  SUBTYPE_DREADNOUGHT       =  59,
  SUBTYPE_DRONE             =  60,
  SUBTYPE_EFREET            =  61,
  SUBTYPE_EGG               =  62,
  SUBTYPE_ELK               =  63,
  SUBTYPE_ELDER             =  64,
  SUBTYPE_ELEMENTAL         =  65,
  SUBTYPE_ELEPHANT          =  66,
  SUBTYPE_ELF               =  67,
  SUBTYPE_ENCHANTMENT       =  68,
  SUBTYPE_FERRET            =  69,
  SUBTYPE_FLAGBEARER        =  70,
  SUBTYPE_MINION            =  71,
  SUBTYPE_FOX               =  72,
  SUBTYPE_FAERIE            =  73,
  SUBTYPE_HOMUNCULUS        =  74,
  SUBTYPE_FROG              =  75,
  SUBTYPE_GOAT              =  76,
  SUBTYPE_GRAVEBORN         =  77,
  SUBTYPE_HARPY             =  78,
  SUBTYPE_FUNGUS            =  79,
  SUBTYPE_HELLION           =  80,
  SUBTYPE_GARGOYLE          =  81,
  SUBTYPE_HIPPO             =  82,
  SUBTYPE_HOMARID           =  83,
  SUBTYPE_GIANT             =  84,
  SUBTYPE_GNOME             =  85,
  SUBTYPE_GOBLIN            =  86,
  SUBTYPE_LIZARD            =  87,
  SUBTYPE_HYENA             =  88,
  SUBTYPE_JELLYFISH         =  89,
  SUBTYPE_SOLDIER           =  90,
  SUBTYPE_GORGON            =  91,
  SUBTYPE_HAG               =  92,
  SUBTYPE_HUMAN             =  93,
  SUBTYPE_HORROR            =  94,
  SUBTYPE_HORSE             =  95,
  SUBTYPE_KAVU              =  96,
  SUBTYPE_HYDRA             =  97,
  SUBTYPE_IMP               =  98,
  SUBTYPE_KIRIN             =  99,
  SUBTYPE_KOR               = 100,
  SUBTYPE_JUGGERNAUT        = 101,
  SUBTYPE_KRAKEN            = 102,
  SUBTYPE_LAMMASU           = 103,
  SUBTYPE_KITHKIN           = 104,
  SUBTYPE_KNIGHT            = 105,
  SUBTYPE_GOLEM             = 106,
  SUBTYPE_KOBOLD            = 107,
  SUBTYPE_LAND              = 108,
  SUBTYPE_LEECH             = 109,
  SUBTYPE_LEGEND            = 110,
  SUBTYPE_MOUNTAIN          = 111,
  SUBTYPE_LICID             = 112,
  SUBTYPE_METATHRAN         = 113,
  SUBTYPE_LEVIATHAN         = 114,
  SUBTYPE_MONGER            = 115,
  SUBTYPE_MONGOOSE          = 116,
  SUBTYPE_DESERT            = 117,
  SUBTYPE_MOONFOLK          = 118,
  SUBTYPE_MUTANT            = 119,
  SUBTYPE_MYSTIC            = 120,
  SUBTYPE_BIRD              = 121,
  SUBTYPE_MANTICORE         = 122,
  SUBTYPE_NAUTILUS          = 123,
  SUBTYPE_NEPHILIM          = 124,
  SUBTYPE_MERFOLK           = 125,
  SUBTYPE_MINOTAUR          = 126,
  SUBTYPE_NINJA             = 127,
  SUBTYPE_MASTICORE         = 128,
  SUBTYPE_OCTOPUS           = 129,
  SUBTYPE_MYR               = 130,
  SUBTYPE_ORB               = 131,
  SUBTYPE_ORGG              = 132,
  SUBTYPE_OYSTER            = 133,
  SUBTYPE_OUPHE             = 134,
  SUBTYPE_NIGHTMARE         = 135,
  SUBTYPE_NOMAD             = 136,
  SUBTYPE_ISLAND            = 137,
  SUBTYPE_OGRE              = 138,
  SUBTYPE_PENTAVITE         = 139,
  SUBTYPE_OOZE              = 140,
  SUBTYPE_ORC               = 141,
  SUBTYPE_FOREST            = 142,
  SUBTYPE_PEGASUS           = 143,
  SUBTYPE_SWAMP             = 144,
  SUBTYPE_PHELDDAGRIF       = 145,
  SUBTYPE_PHOENIX           = 146,
  SUBTYPE_PINCHER           = 147,
  SUBTYPE_PLAINS            = 148,
  SUBTYPE_PRISM             = 149,
  SUBTYPE_RABBIT            = 150,
  SUBTYPE_REFLECTION        = 151,
  SUBTYPE_BARBARIAN         = 152,
  SUBTYPE_RHINO             = 153,
  SUBTYPE_RAT               = 154,
  SUBTYPE_CAT               = 155,
  SUBTYPE_ROGUE             = 156,
  SUBTYPE_RIGGER            = 157,
  SUBTYPE_SALAMANDER        = 158,
  SUBTYPE_SCOUT             = 159,
  SUBTYPE_SATYR             = 160,
  SUBTYPE_SCARECROW         = 161,
  SUBTYPE_SCORPION          = 162,
  SUBTYPE_SERPENT           = 163,
  SUBTYPE_SHADE             = 164,
  SUBTYPE_PERMANENT         = 165,
  SUBTYPE_FISH              = 166,
  SUBTYPE_PIRATE            = 167,
  SUBTYPE_SAMURAI           = 168,
  SUBTYPE_SAPROLING         = 169,
  SUBTYPE_SERF              = 170,
  SUBTYPE_SKELETON          = 171,
  SUBTYPE_SLUG              = 172,
  SUBTYPE_SHEEP             = 173,
  SUBTYPE_SLITH             = 174,
  SUBTYPE_SPAWN             = 175,
  SUBTYPE_SPECTER           = 176,
  SUBTYPE_SPHINX            = 177,
  SUBTYPE_SPIDER            = 178,
  SUBTYPE_SPIRIT            = 179,
  SUBTYPE_SOLTARI           = 180,
  SUBTYPE_SPELLSHAPER       = 181,
  SUBTYPE_GRIFFIN           = 182,
  SUBTYPE_SPIKE             = 183,
  SUBTYPE_TURTLE            = 184,
  SUBTYPE_THOPTER           = 185,
  SUBTYPE_TREEFOLK          = 186,
  SUBTYPE_TROLL             = 187,
  SUBTYPE_NOT_USED_1        = 188,
  SUBTYPE_SPLINTER          = 189,
  SUBTYPE_UNICORN           = 190,
  SUBTYPE_VAMPIRE           = 191,
  SUBTYPE_SPONGE            = 192,
  SUBTYPE_SQUID             = 193,
  SUBTYPE_SQUIRREL          = 194,
  SUBTYPE_STARFISH          = 195,
  SUBTYPE_WARRIOR           = 196,
  SUBTYPE_WALL              = 197,
  SUBTYPE_SURVIVOR          = 198,
  SUBTYPE_THALAKOS          = 199,
  SUBTYPE_THRULL            = 200,
  SUBTYPE_WIZARD            = 201,
  SUBTYPE_WOLVERINE         = 202,
  SUBTYPE_WOLF              = 203,
  SUBTYPE_WOMBAT            = 204,
  SUBTYPE_WORLD             = 205,
  SUBTYPE_WRAITH            = 206,
  SUBTYPE_TRISKELAVITE      = 207,
  SUBTYPE_WURM              = 208,
  SUBTYPE_YETI              = 209,
  SUBTYPE_ZOMBIE            = 210,
  SUBTYPE_NONE              = 211,
  SUBTYPE_CROCODILE         = 212,
  SUBTYPE_ILLUSION          = 213,
  SUBTYPE_INSECT            = 214,
  SUBTYPE_VEDALKEN          = 215,
  SUBTYPE_VOLVER            = 216,
  SUBTYPE_WEIRD             = 217,
  SUBTYPE_SNAKE             = 218,
  SUBTYPE_SAND              = 219,
  SUBTYPE_TETRAVITE         = 220,
  SUBTYPE_WHALE             = 221,
  SUBTYPE_WORM              = 222,
  SUBTYPE_ZUBERA            = 223,
  SUBTYPE_ASSEMBLY_WORKER   = 224,
  SUBTYPE_HOUND             = 225,
  SUBTYPE_LHURGOYF          = 226,
  SUBTYPE_TRIBAL            = 227,
  SUBTYPE_SHRINE            = 228,
  SUBTYPE_CARRIER           = 229,
  SUBTYPE_MERCENARY         = 230,
  SUBTYPE_REBEL             = 231,
  SUBTYPE_VIASHINO          = 232
} subtype_t;

#endif
