#include "manalink.h"


int boost_creature_type(int player, int card, event_t event, subtype_t type,
                         int power, int toughness, int abilities, bct_t flags)
{
  if( ! in_play(player, card) )
    return 0;

  if((flags & BCT_CONTROLLER_ONLY) && (affected_card_controller != player))
    return 0;

  if(!(flags & BCT_INCLUDE_SELF) && (affected_card_controller == player) && (affected_card == card))
    return 0;

  if(!has_creature_type(affected_card_controller, affected_card, type))
    return 0;

  if(event == EVENT_POWER)
    event_result += power;
  else if(event == EVENT_TOUGHNESS)
    event_result += toughness;
  else if(event == EVENT_ABILITIES)
    event_result |= abilities;

  return 0;
}
