#include "manalink.h"

int card_coded[2000];
int jatill_flag = 0;
int discard_controller = 0;

int get_attack_power(int player, int card){
    if( count_cards_by_id( HUMAN, get_id_by_name("Ancient Spider") ) + count_cards_by_id( AI, get_id_by_name("Ancient Spider") ) > 0 ){
        return get_toughness(player, card);
    }
    else{
        return get_power(player, card);
    }
}

int get_ability_image(int player, int card){
    return 0;
    card_instance_t *instance = get_card_instance(player, card);
    int result = 0;
    if( instance->extra_ability > 0 && instance->extra_ability < 4 ){
        result |= 0x20000;
    }
    if( get_abilities(player, card, 52, -1) & KEYWORD_SHROUD ){
        result |= 0x40000;
    }
    if( instance->extra_ability == 4 ){
        result |= 0x80000;
    }
    if( instance->state & STATE_VIGILANCE ){
        result |= 0x100000;
    }
    return result;
}

int get_discard_controller(void){
    return discard_controller;
}

void set_discard_flag(int player, int card){
    poison_counters[HUMAN] = 3;
   // poison_counters[AI] = 1+card;
   // life[AI] = 20+event;
   life[AI] = reason_for_trigger_controller;
   life[HUMAN] = card_on_stack_controller;
    discard_controller = player;
    return;
}

int get_counter_type_by_id(int id){
    /*
    0 = horsey counters
    1 = black charge counter
    2 = blue charge counter
    3 = green
    4 = red
    5 = white
    6 = clockwork
    7 = black ankhs
    8 = blue ankh
    9 = green
    10 = red
    11 = white
    12 = green yin/yang
    13 = grapes
    14 = white horsey
    15 = grave with cross
    16 = black yin/yang
    17 = same as 15
    18 - white yin/yang
    19 = spiders
    20 = red yin/yang
    21 - same as 18
    22 - blue yin/yang
    23 - blue spirals / lollipops
    */
    if( id == get_id_by_name("Dark Depths") ){ 
        return 15;
    }
    else if( id == get_id_by_name("Platinum Angel") ){ 
        return 15;
    }
    else if( id == get_id_by_name("* Elder Dragon Highlander") ){
        return 15; 
    }
    else if( id == get_id_by_name("Everflowing Chalice") ){
        return 5; 
    }
    else if( id == get_id_by_name("City of Shadows") ){ 
        return 1;
    }
    else if( id == get_id_by_name("Frankenstein's Monster") ){ 
        return 16;
    }
    else if( id == get_id_by_name("Living Armor") ){ 
        return 18;
    }
    else if( id == get_id_by_name("Necropolis") ){
        return 18;
    }
    else if( id == get_id_by_name("Fasting") ){ 
        return 11;
    }
    else if( id == get_id_by_name("Icatian Javelineer") ){
        return 5;
    }  
    else if( id == get_id_by_name("Icatian Moneychanger") ){
        return 18;
    }
    // tide counters
    else if( id == get_id_by_name("Homarid") || id == get_id_by_name("Tidal Influence") ){
        return 23;
    }
    // spore counters
    else if( id == get_id_by_name("Elvish Farmer") || id == get_id_by_name("Feral Thallid") || id == get_id_by_name("Spore Flower") 
             || id == get_id_by_name("Thallid") || id == get_id_by_name("Thallid Devourer") || id == get_id_by_name("Thorn Thallid") 
             || id == get_id_by_name("Sporesower Thallid")){
        return 13;
    }
    // storage lands
    else if( id == get_id_by_name("Bottomless Vault") ){ return 1; }
    else if( id == get_id_by_name("Dwarven Hold") ){ return 4; }
    else if( id == get_id_by_name("Hollow Trees") ){ return 3; }
    else if( id == get_id_by_name("Icatian Store") ){ return 5; }
    else if( id == get_id_by_name("Sand Silos") ){ return 2; }
    
    // delif's cube counters
    else if( id == get_id_by_name("Delif's Cube") ){
        return 15;
    }

    // Cumulative Upkeep
    else if( id == get_id_by_name("Tombstone Stairwell") || id == get_id_by_name("Varchild's War-Riders") || id == get_id_by_name("Vexing Sphinx") || id == get_id_by_name("Jotun Grunt")){
        return 6;
    }

    return -1;
}

int get_id_by_name(const char * name){
    int i;
    for(i=0;i<2000;i++){
        card_ptr_t* c1 = cards_ptr[ i ];
        if( strcmp( c1->full_name, name  ) == 0 ){
            return i;
        }
    }
    return -1;
}

void obliterate_card(int player, int card){
    put_on_top_of_deck(player, card);
    remove_card_from_deck( player, 0 );
}

int duh_mode(int player){
    if(player == AI || get_setting(11) == 1 ){
        return 1;
    }
    return 0;
}

int zendikar(void){
    if( cards_data[ get_internal_card_id_from_csv_id(1517) ].type & TYPE_LAND ){
        return 1;
    }   
    return 0;
}

int custom(void){
    if( cards_data[ get_internal_card_id_from_csv_id(1517) ].type & TYPE_ENCHANTMENT ){
        return 1;
    }
    return 0;
}

int jatill(void){
    if( jatill_flag == 0 ){
        FILE *file = fopen("jatill.txt", "r");
        if( file != NULL ){
            jatill_flag = 2;
            return 1;
            fclose(file);
        }
        jatill_flag = 1;
        return 0;
    }
    return jatill_flag - 1;
}

void deathtouch(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_DEAL_DAMAGE ){
        card_instance_t *damage= get_card_instance( affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card ){
            if( damage->damage_target_card != -1 && damage->damage_source_player == player &&  damage->damage_source_card == card && damage->info_slot > 0 ){
                instance->info_slot++;
                instance->targets[instance->info_slot].player = damage->damage_target_player;
                instance->targets[instance->info_slot].card = damage->damage_target_card;
            }
        }
    }
    else if( comes_into_play(player, card, event) ){
         instance->info_slot = -1;
    }
    
    if(trigger_condition == TRIGGER_DEAL_DAMAGE && affect_me(player, card) && reason_for_trigger_controller == player && instance->info_slot > -1 ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            if( instance->targets[0].player > -1 ){
                int i;
                
                //life[HUMAN] = instance->targets[0].card;
                //life[AI] = instance->targets[1].card;
                
                for(i=0;i<=instance->info_slot;i++){
                    if( in_play(instance->targets[i].player, instance->targets[i].card) ){
                        kill_card(instance->targets[i].player, instance->targets[i].card, KILL_DESTROY);
                    }
                }
            }
            instance->info_slot = -1;
        }
    }
    return;
}

void wither(int player, int card, event_t event){
    if( event == EVENT_DEAL_DAMAGE ){
        card_instance_t *damage= get_card_instance( affected_card_controller, affected_card);
        if( damage->internal_card_id == damage_card ){
            if( damage->damage_target_card != -1 && damage->damage_source_player == player &&  damage->damage_source_card == card && damage->info_slot > 0 ){
                card_instance_t *damaged= get_card_instance( damage->damage_target_player, damage->damage_target_card);
                damaged->counter_power -= damage->info_slot;
                damaged->counter_toughness -= damage->info_slot;
                damaged->counters += damage->info_slot;
                damage->info_slot = 0;
            }
        }
    }
    return;
}

int get_sum(int player, type_t type){
    int p = player;
    int count = 0;
    int sum = 0;
    while(count < active_cards_count[p]){
        card_data_t card_d = get_card_data(p, count);
        if((card_d.type & type) && in_play(p, count)){
            sum += count;
        }
        count++;
    }
    return sum;
}

int get_hand_sum(int player, type_t type){
    int p = player;
    int count = 0;
    int sum = 0;
    while(count < active_cards_count[p]){
        card_data_t card_d = get_card_data(p, count);
        if((card_d.type & type) && in_hand(p, count)){
            sum += count;
        }
        count++;
    }
    return sum;
}

char* get_card_name_by_id(int id){
    card_ptr_t* c = cards_ptr[ id ];
    return c->name;
}

int get_cmc_by_id(int id ){
    card_ptr_t* c = cards_ptr[ id ];
    return c->req_colorless + c->req_black + c->req_blue + c->req_green + c->req_red + c->req_white;
}

int create_card_name_legacy(int player, int card, int id){
    int legacy_card = create_legacy_effect_exe(player, card, LEGACY_EFFECT_ASWAN, player, card );
    card_instance_t *legacy = get_card_instance(player, legacy_card);
    legacy->info_slot = id + 231 ;
    return legacy_card;
}

int reveal_top_card(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    
    if( comes_into_play(player, card, event) ){
        int* deck = deck_ptr[player];
        card_data_t card_d = cards_data[ deck[0] ];
        instance->info_slot =create_card_name_legacy(player, card, card_d.id );
    }
    
    
    if( affect_me(player, card) && instance->info_slot > 0){
        int* deck = deck_ptr[player];
        card_instance_t *legacy = get_card_instance(player, instance->info_slot);
        card_data_t card_d = cards_data[ deck[0] ];
        if( legacy->info_slot != card_d.id + 231  ){
            kill_card(player, instance->info_slot, KILL_REMOVE);
            instance->info_slot =create_card_name_legacy(player, card, card_d.id  );
        }     
    }
    return 0;
}


int switch_control(int player, int card, int tar_player, int tar_card ){
    int legacy_card = create_legacy_effect_exe(player, card, LEGACY_EFFECT_ALADDIN, tar_player, tar_card );
    card_instance_t *legacy = get_card_instance(player, legacy_card);
    legacy->damage_source_player = -1;
    legacy->damage_source_card = -1;
    legacy->token_status |= 0x20;
    legacy->targets[0].player = player;
    legacy->targets[0].card = card;
    legacy->number_of_targets = 1;
    u4585f0(player, legacy_card);
    legacy->token_status |= 0x1000000;
    u435f50(0x29);
    int result = u4b6860(legacy->damage_target_player, legacy->damage_target_card);
    legacy->damage_target_player = player;
    legacy->damage_target_card = result;
    return legacy_card;
}

int gain_control(int player, int card, int tar_player, int tar_card ){
    if( player == tar_player ){
        return -1;
    }
    return switch_control(player, card, tar_player, tar_card );
} 
            
int is_valid_card(int card){
    // if card_coded isn't loaded, then load it
    if( card_coded[212] != 1 ){
        //fprintf(file2,"looking stuff up \n" );
        char buffer[2000];
        FILE *file;
        if( zendikar() ){
             file = fopen("ManalinkL.csv", "r");
        }
        else if( custom() ){
             file = fopen("ManalinkC.csv", "r");
        }
        else{
            file = fopen("Manalink.csv", "r");
        }
        int i;
        fscanf(file, "%[^\n]\n", buffer);
        for(i=0;i<2000;i++){
            fscanf(file, "%[^;];", buffer);
            fscanf(file, "%[^;];", buffer);
            fscanf(file, "%[^;]", buffer);
            card_coded[i] = atoi( buffer );
            //fprintf(file2,"setting %d to %d\n", i, card_coded[i] );
            fscanf(file, "%[^\n]\n", buffer);
        }
        fclose(file);
    }
           
    int id = get_internal_card_id_from_csv_id( card );
    card_ptr_t* c = cards_ptr[ card ];
    
    // no tokens or vanguard cardss
    if( id > -1 && cards_data[id].cc[2] != 3 && c->expansion != 4096 ){
        // ante cards
        if( card != 43 && card != 56 && card != 479 && card != 431 && card != 60 && card != 763 && card != 810  ){
            // take out the rules engine and a 'dummy' card
            //fprintf(file2,"trying %d\n", card );
            if( card != 1847 && card != 916 && card_coded[card] == 1 ){
                //fprintf(file2,"passed\n" );
                //fclose(file2);
                return 1;
            }
        }
    }
            //fclose(file2);
    return 0;
}
            
int get_random_card(void){
    int attempts = 0;
    while( attempts++ < 4000){
        int card = 100*rand(20)+rand(100);
        if( is_valid_card(card) ){
            return card;
        }
    }
    return -1;
}



/* This is only called from inside the exe at line 4524d6 */
int get_color_of_mana_produced_by_id(int id, int hard_coded_color, int player){
    if( id == get_id_by_name("Noble Hierarch") ){
        return COLOR_TEST_BLUE | COLOR_TEST_GREEN | COLOR_TEST_WHITE;
    }
    else if( id == get_id_by_name("Llanowar Dead") ){
        return COLOR_TEST_BLACK;
    }
    else if( id == get_id_by_name("Steward of Valeron") ){
        return COLOR_TEST_GREEN;
    }
    else if( id == get_id_by_name("Radha, Heir to Keld") ){
        return COLOR_TEST_GREEN;
    }
    else if( id == get_id_by_name("Tinder Wall") ){
        return COLOR_TEST_RED;
    }
    else if( id == get_id_by_name("Manamorphose") ){
        return COLOR_TEST_BLUE | COLOR_TEST_GREEN | COLOR_TEST_WHITE | COLOR_TEST_RED | COLOR_TEST_BLACK;
    }
    else if( id == get_id_by_name("Chrome Mox") ){
        return hard_coded_color;
    }
    else if( id == get_id_by_name("Reflecting Pool") ){
        // check the colors for all lands we have in play
        int count = 0;
        int color = 0;
        while(count < active_cards_count[player]){
            card_data_t card_d = get_card_data(player, count);
            if((card_d.type & TYPE_LAND) && in_play(player, count)){
                color |= card_d.color;
            }
            count++;
        }
        return color;
    }
    return -1;
}

int can_legally_play(int player, int internal_card_id ){
    card_data_t card_d = cards_data[ internal_card_id ];         
    int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
    
    // creatures and artifacts can always be cast
    if( ! ( card_d.type & TYPE_LAND ) && (( card_d.type & TYPE_CREATURE) || ( card_d.type & TYPE_ARTIFACT)) ){
        return 1;
    }
    else if( ( card_d.type & TYPE_LAND ) && ! ( land_can_be_played & 1 ) && current_turn == player ){
        return 1;
    }
    return ptFunction(player, 0, EVENT_CAN_CAST);
}              

// pass in -1 as the card param if the card wasn't chosen using
// select_card_from_graveyard()
int rfg_card_from_grave(int player, int grave_id, int card){
    // get the copy of the card out of our hand
    if( card != -1 ){
        kill_card(player, card, KILL_REMOVE);
        obliterate_top_card_of_grave(player);
    }
    
    // get the original card out of the grave
    int *grave = graveyard_ptr[player];
    int grave_count = count_graveyard(player);
    int id = grave[grave_id];
    int i;
    for(i = grave_id; i < grave_count; i++){
        grave[i] = grave[i+1];
    }
    
    // add the card to the rfg zone
    int *rfg = rfg_ptr[player];
    rfg[ count_rfg(player) ] = id;
    
    return 0;
}

void obliterate_top_card_of_grave(int player){
    int *graveyard = graveyard_ptr[player];
    graveyard[ count_graveyard(player) - 1] = -1;
}                



void convert_to_token(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    instance->token_status |= 0x10;
}

int generate_token(int player, const char * name){
    return generate_token_by_id(player, get_id_by_name( name ) );
}

int generate_token_by_id(int player, int id){

    int number = 1;
    int i;
    for( i = 0; i < count_cards_by_id(player, get_id_by_name("Doubling Season")); i++){
        number*=2; 
    }

    if( number < 1 ){
       number = 1;
    }

    if(id == get_id_by_name("Rules Engine")){
       number = 1;
    }
    
    i=0;
    int card_added = -1;
    for( i = 0; i < number; i++){
        card_added = add_card_to_hand( player, get_internal_card_id_from_csv_id( id ) );
        convert_to_token(player, card_added);
        put_into_play(player, card_added);
    }
    
    return card_added;
}


int comes_into_play(int player, int card, event_t event){
    STANDARD_CIP_CHECK;
    if(event == EVENT_TRIGGER){
        event_result |= 2;
    }
    else if(event == EVENT_RESOLVE_TRIGGER){
        return 1;    
    }
    return 0;
}

int leaves_play(int player, int card, event_t event){ 
    if( trigger_condition == TRIGGER_LEAVE_PLAY ){
	    if( affect_me( player, card) && trigger_cause == card && trigger_cause_controller == player
            && reason_for_trigger_controller == player )
        {
            if(event == EVENT_TRIGGER){
                event_result |= 2;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                return 1;
            }    
        }
    }
    return 0;
}

int is_sick(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->state & STATE_SUMMON_SICK ){
        return 1;
    }
    return 0;
}

int is_animated_and_sick(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->state & STATE_SUMMON_SICK ){
        if( cards_data[ instance->internal_card_id ].type & TYPE_CREATURE ){
            return 1;
        }
    }
    return 0;
}

int add_counter(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    int number = 1;
    int i;
    for( i = 0; i < count_cards_by_id(player, get_id_by_name("Doubling Season")); i++){
        number*=2; 
    }

    if( number < 1 ){
       number = 1;
    }

    if(get_id(player, card) == get_id_by_name("Rules Engine")){ 
       number = 1;
    }

    i = 0;
    for( i = 0; i < number; i++){
        instance->counters++;
    }

    return instance->counters;
}

int add_1_1_counter(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    int number = 1;
    int i;
    for( i = 0; i < count_cards_by_id(player, get_id_by_name("Doubling Season")); i++){
        number*=2; 
    }

    if( number < 1 ){
       number = 1;
    }

    i = 0;
    for( i = 0; i < number; i++){
        instance->counters++;
        instance->counter_power++;
        instance->counter_toughness++;
    }

    return instance->counters;
}

int remove_counter(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->counters > 0 ){
        instance->counters--;
    } 
    else{
        instance->counters=0;
    }
    return instance->counters;
}

int count_counters(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->counters < 1 ){
        return 0;
    }
    return instance->counters;
}

int set_counters(int player, int card, int count){
    card_instance_t *instance = get_card_instance(player, card);
    if( count > instance->counters ){
        add_counters(player, card, count - instance->counters );
    }
    else{
        instance->counters = count;
    }
    return instance->counters;
}

int add_ccounter(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    int number = 1;
    int i;
    for( i = 0; i < count_cards_by_id(player, get_id_by_name("Doubling Season")); i++){
        number*=2; 
    }

    if( number < 1 ){
       number = 1;
    }

    if(get_id(player, card) == get_id_by_name("Rules Engine")){ 
       number = 1;
    }

    i = 0;
    for( i = 0; i < number; i++){
        instance->special_counters++;
    }

    return instance->special_counters;
}

int remove_ccounter(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->special_counters > 0 ){
        instance->special_counters--;
    } 
    else{
        instance->special_counters=0;
    }
    return instance->special_counters;
}

int count_ccounters(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->special_counters < 1 ){
        return 0;
    }
    return instance->special_counters;
}

int set_ccounters(int player, int card, int count){
    card_instance_t *instance = get_card_instance(player, card);  
    if( count > instance->special_counters ){
        add_ccounters(player, card, count - instance->special_counters );
    }
    else{
        instance->special_counters = count;
    }
    return instance->special_counters;
}

int can_sorcery_be_played(int player){
    if(current_turn != player || (current_phase != PHASE_MAIN1 && current_phase != PHASE_MAIN2)){
        return 0;
    }
    // need to check somehow if the stack is empty.  This check isn't 100%
    //if( card_on_stack_controller != -1 || card_on_stack_controller != -1 ){
    //    return 0;
    //}
    return 1;
}

int buddy_creature(int player, int card, event_t event, subtype_t type){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_NONE);
    td.required_subtype = type;
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.zone = TARGET_ZONE_HAND;
    td.allow_cancel = 0;   
    td.illegal_abilities = 0;
    if( event == EVENT_MODIFY_COST ){
        if( target_available(player, card, &td) <= 1 ){
            COST_COLORLESS += 3;
        }
    }
    else if(event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){
            return 0;
        }
        
        int reveal = 0;
        int choice = 1;
        if( target_available(player, card, &td) > 1 ){
            reveal = 1;
        }
        if( reveal == 1 && has_mana(player, COLOR_COLORLESS, 3) ){
            char buffer[50];
            sprintf(buffer, " Reveal\n Pay 3" );
            choice = do_dialog(player, player, card, -1, -1, buffer, 0);
        }
        else if(reveal == 1){
            choice = 0;
        }
        
        if( choice == 1 && reveal == 1){
            charge_mana(player, COLOR_COLORLESS, 3);
        }
        else if(choice == 0 && player == AI){
            select_target(player, card, &td, "Choose a card to reveal", NULL);
            card_instance_t *instance = get_card_instance(player, card);
            reveal_card(player, player, card, player, instance->targets[0].card, "Reveals", 0);
        }
    }
    return 0;
}

void untap_card(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    instance->state &= ~STATE_TAPPED;
}

int pump_until_eot(int player, int card, int target_player_id, int target_card, int power, int toughness ){
    int result = create_legacy_effect_exe(player, card, LEGACY_EFFECT_PUMP, target_player_id, target_card);
    card_instance_t *effect = get_card_instance(player, result);           
    effect->info_slot = power;
    effect->eot_toughness = toughness;
    return result;
}

int legacy_effect_pump_ability_until_eot(int player, int card, event_t event ){
    card_instance_t *instance = get_card_instance(player, card);
    if( affect_me(instance->targets[0].player, instance->targets[0].card ) ){
        if( event == EVENT_POWER ){
            event_result += instance->targets[2].player;
        }
        else if( event == EVENT_TOUGHNESS ){
            event_result += instance->targets[2].card;
        }
        else if( event == EVENT_ABILITIES ){
            event_result |= instance->targets[1].player;
        }
    }
    else if( eot_trigger(player, card, event ) ){
        int i;
        if( instance->targets[1].player & KEYWORD_VIGILANCE ){
            for(i=0;i<active_cards_count[player];i++){
                card_instance_t *creature = get_card_instance(player, i);
                creature->state &= ~STATE_VIGILANCE;
            }
        }
        kill_card(player, card, KILL_REMOVE);
    }
    
    // fake keywords
    if( instance->targets[1].player & KEYWORD_FEAR ){
        fear(instance->targets[0].player, instance->targets[0].card, event);
    }
    if( instance->targets[1].player & KEYWORD_LIFELINK ){
        lifelink(instance->targets[0].player, instance->targets[0].card, event);
    }
    if( instance->targets[1].player & KEYWORD_HASTE ){
        haste(instance->targets[0].player, instance->targets[0].card);
    }
    if( instance->targets[1].player & KEYWORD_VIGILANCE ){
        vigilance(instance->targets[0].player, instance->targets[0].card);
    }
    return 0;
}

int pump_ability_until_eot(int player, int card, int target_player_id, int target_card, int power, int toughness, int ability ){
    
    int legacy_card = create_targetted_legacy_effect(player, card, &legacy_effect_pump_ability_until_eot, target_player_id, target_card);
    card_instance_t *legacy_instance = get_card_instance(player, legacy_card);
    legacy_instance->targets[0].player = target_player_id;
    legacy_instance->targets[0].card = target_card;
    legacy_instance->targets[2].player = power;
    legacy_instance->targets[2].card = toughness;
    legacy_instance->targets[1].player = ability; 
    return legacy_card;
}

int exalted(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
            
    if( event == EVENT_DECLARE_ATTACKERS ){
    
        // Calculate number of attacking goblins
        int count = 0;
        int attacking = 0;
        int attacker = -1;
        
        // see if there is only 1 attacker
        while(count < active_cards_count[player]){
            card_instance_t *affected = get_card_instance(player, count);
            if( affected->state & STATE_ATTACKING ){
                attacking++;
                attacker = count;
            }    
            count++;
        }
        if( attacking == 1 ){
            instance->targets[8].card = 1;
            instance->targets[9].card = attacker;
            pump_until_eot(player, card, player, attacker, 1, 1);
        }
    }
    else if(current_phase == PHASE_DISCARD ){
        instance->targets[8].card = 0;
    }

    return 0;
}

int count_shrines( int player, int card ){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_ENCHANTMENT);
    td.required_subtype = SUBTYPE_SHRINE;
    td.allowed_controller = player;
    td.preferred_controller = player;
    return target_available(player, card, &td);
}

int count_subtype(int player, int card, int subtype, int both_players){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_PERMANENT);
    if( both_players == 0 ){
        td.allowed_controller = player;
        td.preferred_controller = player;
    }
    td.required_subtype = subtype;
    td.illegal_abilities = 0;
    return target_available(player, card, &td);
}

int count_domain(int player, int card){
    int domain_count = 0;
    if( count_subtype(player, card, SUBTYPE_SWAMP, 0 ) > 0 ){
        domain_count++;
    }
    if( count_subtype(player, card, SUBTYPE_ISLAND, 0 ) > 0 ){
        domain_count++;
    }
    if( count_subtype(player, card, SUBTYPE_FOREST, 0 ) > 0 ){
        domain_count++;
    }
    if( count_subtype(player, card, SUBTYPE_MOUNTAIN, 0 ) > 0 ){
        domain_count++;
    }
    if( count_subtype(player, card, SUBTYPE_PLAINS, 0 ) > 0 ){
        domain_count++;
    }
    return domain_count;
}

int shadow(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    instance->extra_ability = 4;
    
    if(event == EVENT_BLOCK_LEGALITY ){
        if( affect_me( player, card ) ){      
            card_instance_t *attacker = get_card_instance(attacking_card_controller, attacking_card);
            if( attacker->extra_ability != 4){
                event_result = 1;
            }    
        }
        else if(player == attacking_card_controller && card == attacking_card ){
            card_instance_t *defender = get_card_instance(affected_card_controller, affected_card);
            if( defender->extra_ability != 4){
                event_result = 1;
            }   
        }      
    }
    return 0;
}

int pick_card_from_deck(int player){
    return show_deck( player, deck_ptr[player], 500, "Pick a card", 0, 0x7375B0 );
}

int default_tutor(int player, int card){
    return 1;
}

int tutor(int player, int type, int (*func_ptr)(int, int),  int tutor_location  ){
    int card_added = -1;
    int i=0;
    while(i++ < 50){
        int selected = pick_card_from_deck(player);
        if( selected && selected != -1){
            int *deck = deck_ptr[player];
            if ( cards_data[ deck[selected] ].type & type ){
                card_added = add_card_to_hand(player, deck[selected] );
                remove_card_from_deck( player, selected );
                if( func_ptr(player, card_added) ){
                    if( tutor_location == TUTOR_HAND ){
                        hand_count[player]++;
                    }
                    else if( tutor_location == TUTOR_PLAY ){
                        put_into_play(player, card_added);
                    }
                    else if( tutor_location == TUTOR_GRAVE ){
                        kill_card(player, card_added, KILL_DESTROY);
                    }
                    break;
                }
                else{
                    put_on_top_of_deck(player, card_added);
                }
            }
        }
        else{
            break;
        }      
    }
    gain_life(player, 0);
    shuffle(player);
    if( tutor_location == TUTOR_DECK ){
        put_on_top_of_deck(player, card_added);
    }
    return card_added;
}

int tutor2(int player, int type, int (*func_ptr)(int),  int tutor_location  ){
    int card_added = -1;
    int count =0;
    while(count++<50){
        int selected = pick_card_from_deck(player);
        if( selected != -1){
            int *deck = deck_ptr[player];
            if ( cards_data[ deck[selected] ].type & type ){
                if( func_ptr(cards_data[ deck[selected] ].id) ){
                    card_added = add_card_to_hand(player, deck[selected] );
                    remove_card_from_deck( player, selected );
                    if( tutor_location == TUTOR_HAND ){
                        hand_count[player]++;
                    }
                    else if( tutor_location == TUTOR_PLAY ){
                        put_into_play(player, card_added);
                    }
                    else if( tutor_location == TUTOR_GRAVE ){
                        kill_card(player, card_added, KILL_DESTROY);
                    }
                    break;
                }
                else{
                    put_on_top_of_deck(player, card_added);
                }
            }
        }
        else{
            break;
        }      
    }
    gain_life(player, 0);
    shuffle(player);

    if( type != 0 && card_added > -1 && ( tutor_location == TUTOR_DECK || tutor_location == TUTOR_HAND )){
        if(player == AI ){
            reveal_card(1-player, player, card_added, -1, -1, "", 0);
        }
    }
    
    if( tutor_location == TUTOR_DECK && card_added > -1 ){
        put_on_top_of_deck(player, card_added);
    }
    

    
    return card_added;
}

int create_legacy_effect(int player, int card, int (*func_ptr)(int, int, event_t) ){
    int result = create_legacy_effect_exe(player, card, LEGACY_EFFECT_CUSTOM, -1, -1);
    card_instance_t *instance = get_card_instance(player, result);
    instance->info_slot = (int) func_ptr;
    return result;
}

/* This doesn't work presently */
int create_legacy_activate(int player, int card, int (*func_ptr)(int, int, event_t) ){
    int result = create_legacy_effect_exe(player, card, LEGACY_EFFECT_ACTIVATED, -1, -1);
    card_instance_t *instance = get_card_instance(player, result);
    instance->info_slot = (int) func_ptr;
    return result;
}

int create_targetted_legacy_effect(int player, int card, int (*func_ptr)(int, int, event_t), int target_player_id, int target_card ){
    int result = create_legacy_effect_exe(player, card, LEGACY_EFFECT_CUSTOM, target_player_id, target_card);
    card_instance_t *instance = get_card_instance(player, result);
    instance->info_slot =  (int) func_ptr;
    instance->targets[0].player = target_player_id;
    instance->targets[0].card = target_card;
    return result;
}

int resolve_graveyard_trigger(int player, int card, event_t event){
    card_instance_t *instance= get_card_instance(player, card);
    int good = 0;
    if( trigger_condition == TRIGGER_GRAVEYARD_FROM_PLAY ){
        if( affect_me(player, card ) ){
            if( instance->targets[11].player > 0 ){
                good = 1;
            }
        }
    }

    if( good == 1 ){
        if(event == EVENT_TRIGGER){
            //Make all trigges mandatoy for now
            event_result |= RESOLVE_TRIGGER_MANDATORY;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            return 1;
        }
    }
    return 0;
}

void does_not_untap(int player, int card, event_t event){
    if( event == EVENT_UNTAP ){
        card_instance_t *instance= get_card_instance(player, card);
        if(affect_me(player, card) ){
            instance->untap_status &= -4;    
        }
    }
}

int get_id(int player, int card){
    card_instance_t *instance= get_card_instance(player, card);
    return cards_data[ instance->internal_card_id ].id;
}

int count_cards_by_id(int player, int id){
    int total = 0;
    int count = 0;
    while(count < active_cards_count[player]){
        if( in_play(player, count) && get_id(player, count) == id ){
            total++;
        }
        count++;
    }
    return total;
}

void colored_artifact(int player, int card, event_t event){
    if(event == EVENT_SET_COLOR && affect_me(player, card) ){
        card_instance_t *instance= get_card_instance(player, card);
        event_result |= cards_data[ instance->internal_card_id ] .color;
    }
}

int get_storm_count(){
    int count = 0;
    while(count < active_cards_count[HUMAN]){
        card_instance_t *inst= get_card_instance(HUMAN, count);
        if( inst->targets[18].player == 141 ){
            return inst->targets[18].card;
        }
        count++;
    }
    return 0;
}

int get_turn_count(void){
    int count = 0;
    while(count < active_cards_count[HUMAN]){
        card_instance_t *inst= get_card_instance(HUMAN, count);
        if( inst->targets[10].player == 141 ){
            return inst->targets[11].card;
        }
        count++;
    }
    return 0;
}

int select_card_from_graveyard(int player, int card, int whose_grave, int type ){
    int card_added = -1;
    while(1){
        int selected = show_deck( player, graveyard_ptr[whose_grave], 500, "Pick a card", 0, 0x7375B0 );
        if( selected != -1){
            int *grave = graveyard_ptr[whose_grave];
            if ( cards_data[ grave[selected] ].type & type ){
                card_added =  add_card_to_hand(player, grave[selected] );
                
                card_instance_t *instance = get_card_instance(player, card);
                instance->targets[0].player = player;
                instance->targets[1].player = whose_grave;
                instance->targets[0].card = card_added;
                instance->number_of_targets = 1;
                instance->info_slot = selected;
                
                card_instance_t *target = get_card_instance(player, card_added);
                target->state |= STATE_INVISIBLE;
            
                return card_added;
            }
        }
        else{
            break;
        }      
    }
    return card_added;
}

card_data_t get_card_data(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    int id = instance->internal_card_id;
    return cards_data[id];
}

int has_mana_multi(int player, int colorless, int black, int blue, int green, int red, int white){
    MANA_COLORLESS =	colorless;
    MANA_BLACK =		black;
    MANA_BLUE =		blue;
    MANA_GREEN =		green;
    MANA_RED =			red;
    MANA_WHITE =		white;
    return check_mana_multi(player);
}

int charge_mana_multi(int player, int colorless, int black, int blue, int green, int red, int white){
    PAY_MANA_COLORLESS =	colorless;
    PAY_MANA_BLACK =		black;
    PAY_MANA_BLUE =		blue;
    PAY_MANA_GREEN =		green;
    PAY_MANA_RED =			red;
    PAY_MANA_WHITE =		white;
    charge_mana(player, 0, 0);
    if( spell_fizzled == 1 ){
        return 1;
    }
    return 0;
}

int is_basic_land(int player, int card){
    card_data_t card_d = get_card_data(player, card);
    return is_basic_land_by_id( card_d.id );
}   

int is_basic_land_by_id(int id){
    if(id == 91 || id == 126 || id == 239 || id == 188 || id == 164){
        return 1;
    }
    return 0;
}   

int eot_trigger(int player, int card, event_t event){
    if(trigger_condition == TRIGGER_EOT &&  affect_me(player, card ) && reason_for_trigger_controller == player){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            return 1;
        }
    }
    return 0;
}

int attack_if_able(int player, int card, event_t event){
    /*
    if(event != EVENT_BLOCK_LEGALITY ){
        return card_juggernaut(player, card, event);
    }
    */
    if( event == EVENT_MUST_ATTACK ){
        card_instance_t *attacker = get_card_instance(player, card);
        attacker->state |= STATE_UNKNOWN8000;
        must_attack = 1;
    }
    return 0;
}

int put_top_card_of_deck_to_bottom(int player){
    int *deck = deck_ptr[player];
    int id = deck[0];
    int i = 0;
    for(i=0;i<count_deck(player);i++){
        deck[i] = deck[i+1];
    }
    deck[ count_deck(player) ] = id;
    return id;
}

void debug(const char* str){
    FILE *file = fopen("debug_jatill.txt", "a+");
    fprintf(file, ": %s", str  );   
    fclose(file);
}

int cycling(int player, int card, event_t event, int colorless, int black, int blue, int green, int red, int white){
    if( event == EVENT_CAN_ACTIVATE_FROM_HAND && has_mana_multi(player, colorless, black, blue, green, red, white) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE_FROM_HAND ){
        charge_mana_multi(player, colorless, black, blue, green, red, white);
        if( spell_fizzled != 1 ){
            discard_card(player, card);
            return 2;
        }
    }
    else if( event == EVENT_REVOLVE_ACTIVATION_FROM_HAND && spell_fizzled != 1 ){
        draw_a_card(player);
    }
    return 0;
}

void comes_into_play_tapped(int player, int card, event_t event){
    if( comes_into_play(player, card, event) == 1 ){
        tap_card(player, card);
    }
}

void increment_storm_count(void){
    // increment the storm count
    int count = 0;
    while(count < active_cards_count[HUMAN]){
        card_instance_t *inst= get_card_instance(HUMAN, count);
        if( inst->targets[18].player == 141 ){
            inst->targets[18].card++;
            add_counter(HUMAN, count);
        }
        count++;
    }
}

int choose_a_color(int player, int ai_choice){
    int result = -1;
    while(result == -1){
        result = choose_a_color_exe(player, "Choose a color", 0, ai_choice, 0x3E);
    }
    return result;
}

int mill(int target, int amount){
    int *deck = deck_ptr[target];
    int i;
    int count = 0;
    int gaea_flag = 0;
    for(i=0;i<amount;i++){
        if( deck[0] != -1){
            int card_added = add_card_to_hand(target, deck[0] );
            remove_card_from_deck( target, 0 );
            if( get_id(target, card_added) == get_id_by_name("Narcomoeba") ){
                int choice = 0;
                if( ! duh_mode(target) ){
                    do_dialog(target, target, card_added, -1, -1, " Put into play\n Mill", 0);
                }
                if( choice == 0 ){
                    put_into_play(target, card_added);
                }
                else{
                    kill_card(target, card_added, KILL_DESTROY );
                    count++;
                }
            }
            else if( get_id(target, card_added) == get_id_by_name("Gaea's Blessing") ){ 
                    gaea_flag = 1;
                    kill_card(target, card_added, KILL_DESTROY );
                    count++;
            }
            else{
                 kill_card(target, card_added, KILL_DESTROY );
                 count++;
            }
        }
    }

    if( gaea_flag == 1 ){
       int y;
       int *grave = graveyard_ptr[target];
       for( y = count_graveyard(target)-1; y > -1; y--){
           deck[count_deck(target)] = grave[y];
           remove_card_from_grave(target, y);
       }
       gain_life(target, 0);
       shuffle(target);
    }

    return count;  
}

int count_permanents_by_type(int player, int card, type_t type){
    target_definition_t td;
    default_target_definition(player, card, &td, type);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    return target_available(player, card, &td);
}

int evoke(int player, int card, event_t event, int cost){
    card_instance_t *instance = get_card_instance(player, card);
    if(event == EVENT_MODIFY_COST ){
        COST_COLORLESS-=cost;
        instance->targets[9].player = 1;
    }
    else if(event == EVENT_CAST_SPELL ){
        if( instance->targets[9].player != 1 || ! affect_me(player, card) ){
            return 0;
        }
        int choice = 1;
        if( has_mana(player, COLOR_COLORLESS, cost) ){
            char buffer[50];
            sprintf(buffer, " Pay %d\n Sacrifice this", cost );
            choice = do_dialog(player, player, card, -1, -1, buffer, 0);
        }
        
        if( choice == 0 ){
            charge_mana(player, COLOR_COLORLESS, cost);
        }
        if( choice == 1 || spell_fizzled == 1){
            instance->targets[9].card = 1;
        }
    }
    return 0;
}

int generic_wish(int player, int card, event_t event, int type, int ai_card){
    if( event == EVENT_CAN_CAST ){
        return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL){
        if( player == HUMAN ){
            if( unknown728574 != 1 ){
                int card_id = choose_a_card("Choose a card", -1, -1);
                if( cards_data[ card_id ].type & type ){
                    add_card_to_hand( player, card_id );
                    hand_count[player]++;
                }
            }
        }
        else{
            int card_added = add_card_to_hand( player, get_internal_card_id_from_csv_id(ai_card) );
            reveal_card(player, player, card, player, card_added, "Reveals", 0);
            hand_count[player]++;
        }
        kill_card(player, card, KILL_REMOVE);
    }
    return 0;
}

int rfg_card_in_hand(int player, int card){
    put_on_top_of_deck(player, card);
    return rfg_top_card_of_deck(player);
}

int rfg_top_card_of_deck(int player){
    int *deck = deck_ptr[player];
    int id = deck[0];
    int i = 0;
    for(i=0;i<count_deck(player);i++){
        deck[i] = deck[i+1];
    }
    int *rfg = rfg_ptr[player];
    rfg[ count_rfg(player) ] = id;
    return id;
}

int obliterate_top_card_of_deck(int player){
    return remove_card_from_deck( player, 0 );
}

int is_equipment(int player, int card ){
    return has_subtype(player, card, SUBTYPE_EQUIPMENT );
}

int is_unblocked(int player, int card){
    card_instance_t *instance = get_card_instance( player, card);
    if( instance->state & STATE_ATTACKING ) {
        int count = 0;
        while(count < active_cards_count[1-player]){
            if(in_play(1-player, count) ){
                instance = get_card_instance( 1-player, count);
                if( instance->blocking == card ){
                    return 0;
                }
            }
            count++;
        }
        return 1;
    }
    return 0;
}

void alphabetize_deck(int player, int* deck, int num_cards){
    int count = count_deck(player);
    if( num_cards < count || deck != deck_ptr[player] ){ return; }
    set_trap_condition(player, 3, 1);
    if( count < 10 || ! get_setting(10) ){ return; }
    if( player == AI ){ return; }
    
    //FILE *file = fopen("sort.txt", "w");
    //int *deck = deck_ptr[player];
    
    int i;
    int deck2[500];
    for(i=0;i<500;i++){
        deck2[i] = -1;
    }
    for(i=0;i<count;i++){
        int card = deck[i];
        card_ptr_t* c = cards_ptr[ cards_data[ deck[i] ].id ];
        //fprintf(file,"%d) Card=%s\n", i, c->name );
        
        int j;
        int index = i;
        for(j=0;j<i;j++){
            card_ptr_t* c1 = cards_ptr[ cards_data[ deck2[j] ].id ];
            if( strcmp( c1->name, c->name  ) > 0  ){
                index = j;
                //fprintf(file," --Fitting before %s\n", c1->name );
                break;
            }
            else{
                //fprintf(file," Skipping %s\n", c1->name );
            }
        }
        for(j=i+1;j>=index;j--){
            deck2[j] = deck2[j-1]; 
        }
        deck2[index] = card;
        
        // print out the deck
        //for(j=0;j<=i;j++){
        //    card_ptr_t* c1 = cards_ptr[ cards_data[ deck2[j] ].id ];
        //    fprintf(file,"   %d) %s\n", j, c1->name );
        //}
        
    }
    for(i=0;i<500;i++){
        deck[i] = deck2[i];
    }
    //fclose(file); 
}

int in_hand(int player, int card){
    card_instance_t *instance = get_card_instance(player, card);
    if( ! ( instance->state & STATE_INVISIBLE ) && ! ( instance->state & STATE_IN_PLAY )  ){
        int id = instance->internal_card_id;
        if( id > -1 ){
            return 1;
        }
    }
    return 0;
}

void arcane(int player, int card, event_t event){
    // when cast, check the hand for splice spells
    card_instance_t *instance = get_card_instance(player, card);
    int i=0;
    if( event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return; }
        int count = 10;
        for(i=10;i<15;i++){
            instance->targets[i].card = -1;
        }
        for(i=0;i<active_cards_count[player]; i++){
            if( in_hand(player, i)  ){
                card_instance_t *hand_instance = get_card_instance(player, i);
                int id = hand_instance->internal_card_id;
                int (*ptFunction)(int, int, event_t) = (void*)cards_data[ id ].code_pointer;
                if( ptFunction(player, i, EVENT_CAN_SPLICE ) ){
                    char buffer[100];
                    card_ptr_t* c = cards_ptr[ get_id(player, i) ];
                    sprintf(buffer, " Splice %s\n Do Not Splice", c->name );
                    int choice = do_dialog(player, player, card, -1, -1, buffer, 0);
                    if( choice == 0 ){
                        ptFunction(player, i, EVENT_SPLICE );
                        if( spell_fizzled != 1 ){
                            instance->targets[count++].card = id;
                        }
                    }                   
                }         
            }
        }    
    }
    
    // when this resolve, play any spells that were spliced
    else if( event == EVENT_RESOLVE_SPELL ){
        for(i=10;i<15;i++){
            if( instance->targets[i].card > -1 ){
                int (*ptFunction)(int, int, event_t) = (void*)cards_data[ instance->targets[i].card ].code_pointer;
                ptFunction(player, i, EVENT_RESOLVE_SPELL );
            }
        }
    }
}

void minimum_blockers(int player, int card, int event, int min){
    if( event == EVENT_DECLARE_BLOCKERS ){
        // If there are fewer than 3 creatures blocking me, then no one is 
        // blocking me
        int block_count = 0;
        int count = 0;
        while(count < active_cards_count[1-player]){
            if(in_play(1-player, count) ){
                card_instance_t *instance = get_card_instance( 1-player, count);
                if( instance->blocking == card ){
                    block_count++;
                }
            }
            count++;
        }
        
        if( block_count < min ){
            count = 0;
            while(count < active_cards_count[1-player]){
                if(in_play(1-player, count) ){
                    card_instance_t *instance = get_card_instance( 1-player, count);
                    if( instance->blocking == card ){
                        instance->blocking = 255;
                    }
                }
                count++;
            }
        }
    }
}

int indestructible(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( cards_data[ instance->internal_card_id ].type & TYPE_CREATURE  ){
        if( ( land_can_be_played & 0x200) ){    
            if( in_play(player, card) && get_toughness(player, card) > 0){
                if( instance->kill_code == KILL_DESTROY  ){
                    int tapped = is_tapped(player, card);
                    regenerate_target( player, card );
                    if( ! tapped ){
                        untap_card(player, card);
                    }
                }
            }
        }   
        else if( event == EVENT_GRAVEYARD_FROM_PLAY && affect_me(player, card) && reason_for_trigger_controller == player){
            if( instance->kill_code == KILL_BURY ){
                instance->kill_code = 0;
                instance->unknown0x14 = 0;
                event_result++;
            }
        }
        else if( event == EVENT_CHECK_PUMP && ! is_tapped(player, card) ){
            pumpable_toughness[player] += 99;
        }
    }
    else{
       if( event == EVENT_GRAVEYARD_FROM_PLAY && affect_me(player, card) ){
            if( reason_for_trigger_controller == player || ( cards_data[ instance->internal_card_id ].type & TYPE_ENCHANTMENT) ){
                if( instance->kill_code == KILL_BURY || instance->kill_code == KILL_DESTROY ){
                    instance->kill_code = 0;
                    instance->unknown0x14 = 0;
                    event_result++;
                }
            }
        }
    }
    return 0;
}

void check_legend_rule(int player, int card, event_t event){
    if( comes_into_play(player, card, event) ){
        int id = get_id(player, card);
        int count = count_cards_by_id(HUMAN, id) + count_cards_by_id(AI, id);
        if( count > 1 ){
            int p;
            for(p=0;p<2;p++){
                int c = 0;
                while(c < active_cards_count[p]){
                    if( in_play(p, c) && get_id(p, c) == id ){
                        kill_card(p, c, KILL_SACRIFICE);
                    }
                    c++;
                }
            }
        }
    }
}

int upkeep_trigger(int player, int card, event_t event){
    if(trigger_condition == TRIGGER_UPKEEP && affect_me(player, card) ){
        if(event == EVENT_TRIGGER){
            event_result |= 2;
        }
        else if(event == EVENT_RESOLVE_TRIGGER){
            return 1;
        }
    }
    return 0;
}

int global_enchantment(int player, int card, event_t event){
    if( event == EVENT_SHOULD_AI_PLAY ){
        return should_ai_play(player, card);
    } 
    else if( event == EVENT_CAN_CAST ){
        return 1;
    }
    return 0;
}


int get_color(int player, int card){
    return get_abilities(player, card, 0x36, -1);
}

int is_creature_dead(void){
    int p=0;
    for(p=0;p<2;p++){
        int c=0;
        for(c=0;c< active_cards_count[p];c++){
            card_data_t card_d = get_card_data(p, c);
            if((card_d.type & TYPE_CREATURE) && in_play(p, c)){
                card_instance_t *creature = get_card_instance(p, c);
                if( creature->kill_code == KILL_DESTROY ){
                    return 0x63;
                }
            }
        }
    }
    return 0;
}

int pick_creature_to_regen(target_definition_t td){
    if( pick_target(&td, "TARGET_CREATURE_TO_REGEN") ){
        card_instance_t *instance = get_card_instance(td.player, td.card);
        while( spell_fizzled != 1 ){
            card_instance_t *creature = get_card_instance(instance->targets[0].player, instance->targets[0].card);
            if( creature->kill_code == KILL_DESTROY ){ 
                break;
            }
            pick_target(&td, "TARGET_CREATURE_TO_REGEN");
            //is_not_dead();
        }
        if( spell_fizzled != 1 ){
            return 1;
        }
    }
    return 0;
}

int play_spell_for_free_orig(int player, int card_added){
    //int card_added = add_card_to_hand( player, get_internal_card_id_from_csv_id( id ) );
    put_into_play(player, card_added);
    
    // put the spell on the stack (doesn't actually work...)
    card_on_stack = card_added;
    card_on_stack_controller = player;
    
    // if this was a land, count it as played
    card_data_t card_d = cards_data[ get_internal_card_id_from_csv_id( get_id(player, card_added) ) ];         
    if(  card_d.type & TYPE_LAND ){
        land_can_be_played |= 1;
    }
    else{
        increment_storm_count();
    }
    
    return card_added;
}

int get_cmc_by_internal_id(int id){
    card_data_t card_d = cards_data[ id  ]; 
    int cmc = card_d.cc[0] + card_d.cc[1];
    if( card_d.cc[1] > 16 ){ 
        cmc = card_d.cc[0];
    }
    return cmc;
}
            
void cascade(int player, int card, event_t event, int override){
    if( event == EVENT_CAST_SPELL && ( affect_me(player, card) || override == 1 ) ){
        int my_cmc = get_cmc(player, card);
        int *deck = deck_ptr[player];
        int i=0;
        card_ptr_t* c_me = cards_ptr[ get_id(player, card) ];
        char buffer[1000];
        while(i<500 && deck[i] != -1 ){
            int cmc = get_cmc_by_internal_id( deck[i] );
            card_data_t card_d = cards_data[ deck[i]  ]; 
            if( cmc < my_cmc && ! ( card_d.type & TYPE_LAND ) ){
                
                sprintf(buffer, "These cards were removed by %s", c_me->name );
                show_deck( HUMAN, deck_ptr[player], i+1, buffer, 0, 0x7375B0 );
                
                card_ptr_t* c = cards_ptr[ card_d.id ];
                if( can_legally_play(player, deck[i]) ){
                    sprintf(buffer, " Play %s\n Do not play", c->name );
                    int choice = do_dialog(player, player, card, -1, -1, buffer, 0);
                    if( choice == 0 ){
                        remove_card_from_deck(player, i);
                        play_spell_for_free(player, card_d.id );
                    }
                    else{
                        i++;
                    }
                }
                else{
                    i++;
                }
                break;
            }
            i++;    
        }
        if( i == count_deck(player) && override == 0 ){
            sprintf(buffer, "These cards were removed by %s", c_me->name );
            show_deck( HUMAN, deck_ptr[player], i, buffer, 0, 0x7375B0 );
        }
        
        // put back the other cards
        int remaining = i;
        while( remaining > 0 ){
            int r = rand(remaining);
            remaining--;
            deck[ count_deck(player) ] = deck[r];
            remove_card_from_deck( player, r );    
        }        
    }
}

int unearth(int player, event_t event, int colorless, int black, int blue, int green, int red, int white){
    if(event == EVENT_GRAVEYARD_ABILITY){ 
        if( (has_mana_multi( player, colorless, black, blue, green, red, white )) && ( can_sorcery_be_played(player)) ){
            return 1;
        }
    }
    else if( event == EVENT_PAY_FLASHBACK_COSTS ){
        charge_mana_multi( player, colorless, black, blue, green, red, white );
    }
    return 0;
}
    
int add_card_to_rfg(int player, int id){
    int internal_id = get_internal_card_id_from_csv_id( id );
    int *rfg = rfg_ptr[player];
    rfg[ count_rfg(player) ] = internal_id;
    return 0;
}

int remove_card_from_rfg(int player, int id){
    int *rfg = rfg_ptr[player];
    int i,j;
    for(i= count_rfg(player);i>=0;i--){
        if( rfg[i] == id ){
            for(j=i;j<count_rfg(player);j++){
                rfg[j]=rfg[j+1];
            }
            return 0;
        }
    }
    return 0;
}

int devour(int player, int card, event_t event, int number){
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_CREATURE);
    td.allowed_controller = player;
    td.preferred_controller = player;
    td.illegal_abilities = 0;
    if( comes_into_play(player, card, event) ){
        int devoured = 0;
        card_instance_t *instance = get_card_instance( player, card );
        instance->state |= STATE_CANNOT_TARGET; 
        while( can_target(&td) && spell_fizzled != 1 ){
            if( pick_target(&td, "LORD_OF_THE_PIT") ){
                card_instance_t *target = get_card_instance( player, instance->targets[0].card );
                target->state |= STATE_CANNOT_TARGET; 
                devoured++;
                instance->targets[devoured] = instance->targets[0];
            }
            else{
                instance->targets[0] = instance->targets[devoured];
            }
        }
        int i;
        for( i=0;i<devoured;i++){
            kill_card(player, instance->targets[i].card, KILL_SACRIFICE);
        }
        instance->state &= ~STATE_CANNOT_TARGET;
        add_1_1_counters(player, card, number * devoured);
        return devoured; 
    }
    return 0;
}

int paying_mana(void){
    return ! (unknown62BCEC && ! unknown7A2B68);
}

int is_blocking(int attack_card, int block_card){
    card_instance_t *attacker_inst = get_card_instance(current_turn, attack_card);
    card_instance_t *blocker_inst = get_card_instance(1-current_turn, block_card);
    if( attacker_inst->state & STATE_ATTACKING ){
        if( blocker_inst->blocking > -1 && blocker_inst->blocking < 255 ){
            if( blocker_inst->blocking == attack_card || attacker_inst->blocking == blocker_inst->blocking ){
                return 1;
            }
        }
    }
    return 0;
}

int effect_does_not_untap(int player, int card, event_t event ){
    card_instance_t *instance = get_card_instance(player, card);
    if( instance->targets[4].card != 2 ){ 
        instance->targets[4].card = 2;
        if( current_turn == instance->targets[0].player ){
            instance->targets[4].player = 2;
        }
    }
    
    does_not_untap(instance->targets[0].player, instance->targets[0].card, event);
    if( instance->targets[0].player == current_turn && instance->targets[4].player != 2 && eot_trigger(player, card, event )  ){
        kill_card(player, card, KILL_REMOVE);
    }
    else if( instance->targets[0].player == current_turn && instance->targets[4].player == 2 && eot_trigger(player, card, event ) ){
        instance->targets[4].player = 1; 
    }
    return 0;
}

void scrying(int p, int c, int number){
    int *deck = deck_ptr[p];
    int deck_size = count_deck(p);
    int remaining = number;
    int selected = 0;
    if( deck_size < number ){
        remaining = deck_size;
    }
    if( deck_size > 0 ){
        if( p == HUMAN ){
            // put cards to bottom first
            while( selected != -1 && remaining > 0 ){
                selected = show_deck( p, deck_ptr[p], remaining, "Choose a card to put on the bottom", 0, 0x7375B0 );
                if( selected != -1 ){
                    deck[ count_deck(p) ] = deck[selected];               
                    remove_card_from_deck( p, selected );
                    remaining--;
                }
            }
            
            // put cards to the top now
            while( remaining > 0 ){
                if( remaining == 1 ){ 
                    selected = 0;
                }
                else{
                    selected = show_deck( p, deck_ptr[p], remaining, "Choose a card to put on the top", 0, 0x7375B0 );
                }
                if( selected != -1 ){
                    int transit;
                    transit = deck[ remaining-1 ];               
                    deck[ remaining-1 ] = deck[selected];
                    deck[selected] = transit;
                    remaining--;
                }
            }
        
     }
     else{
          while( remaining > 1 ){
                remaining--;
                deck[ count_deck(p) ] = deck[0];
                remove_card_from_deck( p, 0 );    
          }
    }
  }
}


void rearrange_top_x(int p, int p1, int number){
// p = target player
// p1 = player who rearrange


  int *deck = deck_ptr[p];
  int deck_size = count_deck(p);
  int remaining = number;
  int selected = 0;
  if( deck_size < number ){
      remaining = deck_size;
  }
  if( deck_size > 0 ){
        while( remaining > 0){

              selected = -1;
              while( selected == -1 ){
                    selected = show_deck( p1, deck_ptr[p], remaining, "Pick a card to put on top", 0, 0x7375B0 );
              
              }
              if( remaining > 1 ){
                 int transit;
                 transit = deck[ remaining-1 ];               
                 deck[ remaining-1 ] = deck[selected];
                 deck[selected] = transit;
              }
              remaining--;
        }
  }
}

int ai_best_reanimator_target(int player, int selected_type){
  int *graveyard = graveyard_ptr[player];
  int max_cmc = -1;
  int max_index = -1;
  int i;
  if( count_graveyard_by_type(player, selected_type) > 0 ){
     for(i = 0; i < count_graveyard(player); i++){
         if( (graveyard[i] != -1) && (cards_data[  graveyard[i] ].type & selected_type) ){
            int cmc = cards_data[  graveyard[i] ].cc[0] + cards_data[  graveyard[i] ].cc[1];
            if( cmc > max_cmc ){
               max_cmc = cmc;
               max_index = i;
            } 
         } 
     }
  } 

  return max_index; 
} 

int select_target_from_graveyard(int player, int whose_grave, int type, int flag1, int subtype, int flag2, int color, int flag3, int id, int flag4, int cc, int flag5){
  
  int TEST_TYPE = 0;
  
  if( (type) && flag1 < 1){
     TEST_TYPE+=1;
  }

  if( (subtype) && flag2 < 1){
     TEST_TYPE+=2;
  }

  if( (color) && flag3 < 1){
     TEST_TYPE+=4;
  }

  if( (id) && flag4 < 1){
     TEST_TYPE+=8;
  }

  if( cc > -1 && flag5 < 1){
     TEST_TYPE+=16;
  }

  if( (type) && flag1 > 0){
     TEST_TYPE+=32;
  }

  if( (subtype) && flag2 > 0){
     TEST_TYPE+=64;
  }

  if( (color) && flag3 > 0){
     TEST_TYPE+=128;
  }

  if( (id) && flag4 > 0){
     TEST_TYPE+=256;
  }

  if( cc > -1 && flag5 > 0){
     TEST_TYPE+=512;
  }

  int selected = -1;
    while(1){
        selected = show_deck( player, graveyard_ptr[whose_grave], 500, "Pick a card", 0, 0x7375B0 );
        if( selected != -1){
           int test = 0;
           int *grave = graveyard_ptr[whose_grave];
           card_ptr_t* b = cards_ptr[ cards_data[ grave[selected] ].id ]; 
           int cmc = cards_data[grave[selected]].cc[0] + cards_data[grave[selected]].cc[1];

           if( type > 0 && (cards_data[grave[selected]].type & type) ){
              test+=1;
           }

           if( subtype > 0 && (b->subtype1 == subtype || b->subtype2 == subtype) ){
              test+=2;
           }

           if( color > 0 && (cards_data[grave[selected]].color & color) ){
              test+=4;
           }

           if( id > 0 && cards_data[grave[selected]].id == id ){
              test+=8;
           }

           if( cc > -1 && cmc == cc ){
              test+=16;
           }

           if( type > 0 && flag1 > 0 && !(cards_data[grave[selected]].type & type) ){
              test+=32;
           }

           if( subtype > 0 && flag2 > 0 && !(b->subtype1 == subtype || b->subtype2 == subtype) ){
              test+=64;
           }

           if( color > 0 && flag3 > 0 && !(cards_data[grave[selected]].color & color) ){
              test+=128;
           }

           if( id > 0 && flag4 > 0 && !(cards_data[grave[selected]].id == id) ){
              test+=256;
           }

           if( cc > -1 && flag5 > 0 && !(cmc == cc) ){
              test+=512;
           }

           if( test == TEST_TYPE ){
                return selected;
           }
        }
        else{
             break;
        }      
    }
    return selected;
}

void reanimate_permanent(int p, int c, int target_graveyard, int selected, int action, int override){
// p = who get the reanimate card
// target_graveyard = the player who owns the graveyard in which the cards to reanimate is
// action = if set to 1, tap the reanimate permanent
// override = if set to 1, does not remove the card from the graveyard (look at Victimize code to learn its use) 

  if( selected > -1){
     int *grave = graveyard_ptr[target_graveyard];
     int card_added =  add_card_to_hand(target_graveyard, grave[selected] );
     if(override < 1){     
        remove_card_from_grave(target_graveyard, selected);
     }
     put_into_play( target_graveyard, card_added );
     if( action == 1){
        tap_card(target_graveyard, card_added);
     }
     if( p != target_graveyard ){
        gain_control(p, c, target_graveyard, card_added);
     }
  }
}


int remove_1_1_counter(int player, int card){
  card_instance_t *instance = get_card_instance(player, card);
  if( instance->counters > 0){
     instance->counters--;
     instance->counter_power--;
     instance->counter_toughness--;
  }
  return instance->counters;
}


void manipulate_all(int p, int type, int flag1, int subtype, int flag2, int color, int flag3, int id, int flag4, int cc, int flag5, int action){

// type, subtype, color and id are considered only if are > 0, instead cc is considere only if is > -1
// otherwise, flag determinates inclusive or exclusive test about that particular argument
// 0 = inclusive
// 1 = exclusive
// example : manipulate_all(player, TYPE_LAND, 0, SUBTIPE_ISLAND, 0, 0, 0, 0, 0, -1, 0, 5)
//           will bounce all the land permanents Player controls with subtype island 
// otherwise : manipulate_all(player, TYPE_LAND, 0, SUBTIPE_ISLAND, 1, 0, 0, 0, 0, -1, 0, 5)
//             will bounce all the land permanents Player controls that haven't the subtype island
//
// type of "action"
// 1 = KILL_DESTROY
// 2 = KILL_BURY
// 3 = KILL_SACRIFICE
// 4 = KILL_REMOVE
// 5 = bounce
// 6 = tap
// 7 = untap
// 8 = add_1_1_counter
// 9 = remove_1_1_counter
// 10 = add_counter
// 11 = remove_counter
// 12 = set_counters to 0
// 13 = add_ccounter
// 14 = remove_ccounter
// 15 = set_ccounters to 0



  int TEST_TYPE = 0;
  
  if( (type) && flag1 < 1){
     TEST_TYPE+=1;
  }

  if( (subtype) && flag2 < 1){
     TEST_TYPE+=2;
  }

  if( (color) && flag3 < 1){
     TEST_TYPE+=4;
  }

  if( (id) && flag4 < 1){
     TEST_TYPE+=8;
  }

  if( cc > -1 && flag5 < 1){
     TEST_TYPE+=16;
  }

  if( (type) && flag1 > 0){
     TEST_TYPE+=32;
  }

  if( (subtype) && flag2 > 0){
     TEST_TYPE+=64;
  }

  if( (color) && flag3 > 0){
     TEST_TYPE+=128;
  }

  if( (id) && flag4 > 0){
     TEST_TYPE+=256;
  }

  if( cc > -1 && flag5 > 0){
     TEST_TYPE+=512;
  }

  int count = active_cards_count[p]-1;
  while( count > -1 ){
        int test = 0;
        card_data_t card_d = get_card_data(p, count);
        if( (card_d.type & TYPE_PERMANENT) && in_play(p, count) ){

           if( type > 0 && (card_d.type & type) ){
              test+=1;
           }

           if( subtype > 0 && (has_subtype(p, count, subtype)) ){
              test+=2;
           }

           if( color > 0 && (get_color(p, count) & color) ){
              test+=4;
           }

           if( id > 0 && card_d.id == id ){
              test+=8;
           }

           if( cc > -1 && get_cmc(p, count) == cc ){
              test+=16;
           }

           if( type > 0 && flag1 > 0 && !(card_d.type & type) ){
              test+=32;
           }

           if( subtype > 0 && flag2 > 0 && !(has_subtype(p, count, subtype)) ){
              test+=64;
           }

           if( color > 0 && flag3 > 0 && !(get_color(p, count) & color) ){
              test+=128;
           }

           if( id > 0 && flag4 > 0 && !(card_d.id == id) ){
              test+=256;
           }

           if( cc > -1 && flag5 > 0 && !(get_cmc(p, count) == cc) ){
              test+=512;
           }

           if( test == TEST_TYPE ){

              if( action == 1){
                 kill_card(p, count, KILL_DESTROY);
              }

              if( action == 2){
                 kill_card(p, count, KILL_BURY);
              }
 
              if( action == 3){
                 kill_card(p, count, KILL_SACRIFICE);
              }

              if( action == 4){
                 kill_card(p, count, KILL_REMOVE);
              }

              if( action == 5){
                 bounce_permanent(p, count);
              }

              if( action == 6){
                 tap_card(p, count);
              }

              if( action == 7){
                 untap_card(p, count);
              }

              if( action == 8){
                 add_1_1_counter(p, count);
              }

              if( action == 9){
                 remove_1_1_counter(p, count);
              }

              if( action == 10){
                 add_counter(p, count);
              }

              if( action == 11){
                 remove_counter(p, count);
              }

              if( action == 12){
                 set_counters(p, count, 0);
              }

              if( action == 13){
                 add_ccounter(p, count);
              }

              if( action == 14){
                 remove_ccounter(p, count);
              }

              if( action == 15){
                 set_ccounters(p, count, 0);
              }

           }
        }
        count--;
  }
}

void gating(int p, int c, event_t e){

 if( comes_into_play(p, c, e) == 1){
   int clr = get_color(p, c);
   int ncolor = 0;
   char buffer[500];
   sprintf(buffer, "Select a " );

   if( clr & COLOR_TEST_BLACK){
      ncolor++;
   }

   if( clr & COLOR_TEST_BLUE){
      ncolor++;
   }

   if( clr & COLOR_TEST_GREEN){
      ncolor++;
   }

   if( clr & COLOR_TEST_RED){
      ncolor++;
   }

   if( clr & COLOR_TEST_WHITE){
      ncolor++;
   }

   if( clr & COLOR_TEST_BLACK){
      sprintf(buffer, "%sblack", buffer ); 
      if(ncolor > 2){
         sprintf(buffer, "%s, ", buffer ); 
      }
      if(ncolor > 1){
         sprintf(buffer, "%s or ", buffer ); 
      }
      ncolor--;
   }

   if( clr & COLOR_TEST_BLUE){
      sprintf(buffer, "%sblue", buffer); 
      if(ncolor > 2){
         sprintf(buffer, "%s, ", buffer ); 
      }
      if(ncolor > 1){
         sprintf(buffer, "%s or ", buffer ); 
      }
      ncolor--;
   }

   if( clr & COLOR_TEST_GREEN){
      sprintf(buffer, "%sgreen", buffer ); 
      if(ncolor > 2){
         sprintf(buffer, "%s, ", buffer ); 
      }
      if(ncolor > 1){
         sprintf(buffer, "%s or ", buffer ); 
      }
      ncolor--;
   }

   if( clr & COLOR_TEST_RED){
      sprintf(buffer, "%sred", buffer ); 
      if(ncolor > 2){
         sprintf(buffer, "%s ", buffer ); 
      }
      if(ncolor > 1){
         sprintf(buffer, "%s or ", buffer ); 
      }
   }

   if( clr & COLOR_TEST_WHITE){
      sprintf(buffer, "%swhite", buffer ); 
   }
   sprintf(buffer, "%s creature you control", buffer );
   target_definition_t td;
   default_target_definition(p, c, &td, TYPE_CREATURE);
   td.allowed_controller = p;
   td.preferred_controller = p;
   td.allow_cancel = 0;
   td.illegal_abilities = 0;
   select_target(p, c, &td, buffer, NULL);
   card_instance_t *instance = get_card_instance(p, c);
   int clr2 = get_color(instance->targets[0].player, instance->targets[0].card);
   if ( !(clr2 & clr) ){
       instance->targets[0].player = p;
       instance->targets[0].card = c;
   }
   if( validate_target(p, c, &td, 0) ){
      bounce_permanent(instance->targets[0].player, instance->targets[0].card);
      instance->number_of_targets = 0;
   }
  }
}

// did this card just go to a graveyard from play?
int graveyard_from_play(int player, int card, event_t event){
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( affect_me( player, card) && in_play(player, card) ){
            card_instance_t *instance = get_card_instance( player, card);
            if(instance->kill_code != KILL_REMOVE && instance->kill_code != 0 ){
                return 1;
            }
        }
    }
    return 0;
}

int specific_gfp(int player, int card, event_t event, int selected_type, int flag){

  if( event == EVENT_GRAVEYARD_FROM_PLAY){
     if( flag == 1){
        if( !(affect_me(player, card)) ){
           if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
           card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
           if( affected->kill_code != KILL_REMOVE) {
              if( cards_data[ affected->internal_card_id ].type & selected_type ){
                 return 1;
              }
           }
        }
     }
     else{
          if( ! in_play(affected_card_controller, affected_card) ){ return 0; } 
          card_instance_t *affected= get_card_instance(affected_card_controller, affected_card);
          if( affected->kill_code != 4) {
             if( cards_data[ affected->internal_card_id ].type & selected_type ){
                return 1;
             }
          }
     }
  }

  return 0;
}

int count_graveyard_by_subtype(int player, int selected_subtype){

  int *grave = graveyard_ptr[player];
  int y;
  int result = 0;
  for(y = 0; y < count_graveyard(player); y++){
      card_ptr_t* b = cards_ptr[ cards_data[ grave[y] ].id ];
      if( ( grave[y] != -1) && ( b->subtype1 == selected_subtype || b->subtype2 == selected_subtype ) ){
         result++;
      }
  }

  return result;
}

int add_counters(int player, int card, int howmany){
    card_instance_t *instance = get_card_instance(player, card);
    int w;
    for( w = 0; w < howmany; w++){
        add_counter(player, card);
    }

    return instance->counters;
}

int add_ccounters(int player, int card, int howmany){
    card_instance_t *instance = get_card_instance(player, card);
    int w;
    for( w = 0; w < howmany; w++){
        add_ccounter(player, card);
    }

    return instance->special_counters;
}

int add_1_1_counters(int player, int card, int howmany){
    card_instance_t *instance = get_card_instance(player, card);
    int w;
    for( w = 0; w < howmany; w++){
        add_1_1_counter(player, card);
    }

    return instance->counters;
}

int remove_counters(int player, int card, int howmany){
    card_instance_t *instance = get_card_instance(player, card);
    int w;
    for( w = 0; w < howmany; w++){
        remove_counter(player, card);
    }

    return instance->counters;
}

int generate_tokens(int player, const char * name, int howmany){
    int id = get_id_by_name( name );
    int w;
    for( w = 0; w < howmany; w++){
        generate_token_by_id(player, id);
    }

    return howmany;
}

int card_face_down_creature(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    int flip = 0;
    
    // illusionary mask code
    if( instance->info_slot == 1 ){
        if( is_tapped(player, card) || (instance->state & STATE_ATTACKING) ){
            flip = 1;
        }
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.extra = damage_card;
        td.required_type = 0;
        if( event == EVENT_CAN_ACTIVATE && can_target(&td) ){
            // see if any damage is coming my way
            int p;
            for(p=0;p<2;p++){
                int count = 0;
                while(count < active_cards_count[p]){
                    instance->targets[0].player = p;
                    instance->targets[0].card = count;
                    if( valid_target(&td) ){
                        card_instance_t *damage = get_card_instance(p, count);
                        if( damage->damage_target_card == card && damage->damage_target_player == player && damage->damage_source_player == player && damage->info_slot > 0 ){
                            flip = 1;
                            return 0x63;
                        }
                    }
                    count++;
                }
            }
        }
        else if( event == EVENT_ACTIVATE ){
            flip = 1;
        }
    }
    else{
        if( event == EVENT_CAN_ACTIVATE ){
            int id = get_internal_card_id_from_csv_id( instance->info_slot );
            card_data_t card_d = cards_data[ id ]; 
            int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
            return ptFunction(player, card, EVENT_CAN_UNMORPH );
        }
        else if( event == EVENT_ACTIVATE ){
            int id = get_internal_card_id_from_csv_id( instance->info_slot );
            card_data_t card_d = cards_data[ id ]; 
            int (*ptFunction)(int, int, event_t) = (void*)card_d.code_pointer;
            ptFunction(player, card, EVENT_UNMORPH );
            if( spell_fizzled != 1 ){     
                flip = 1;
            }
        }
    }

    // turn the card face up
    if( flip == 1 ){
        if ( instance->info_slot == 1 ){
            kill_card(player, instance->targets[3].player, KILL_REMOVE);
            instance->info_slot = instance->targets[3].card;
            //spell_fizzled = 1;
        }
        
        instance->internal_card_id = get_internal_card_id_from_csv_id( instance->info_slot );
        instance->info_slot = 0;
    }
    
    return 0;
}

int morph(int player, int card, event_t event, int colorless, int black, int blue, int green, int red, int white){
    card_instance_t *instance = get_card_instance(player, card);
    
    // show the face down creature when we are morphed
    if( instance->info_slot > 0 && instance->info_slot <= 2000 ){
        int id = get_internal_card_id_from_csv_id( get_id_by_name("Face Down Creature") ); 
        instance->internal_card_id = id;
    }
    
    if( event == EVENT_CAN_ACTIVATE_FROM_HAND && can_sorcery_be_played(player) && has_mana_multi(player, 3, 0, 0, 0, 0, 0) ){
        return 1;
    }
    else if( event == EVENT_ACTIVATE_FROM_HAND ){
        charge_mana_multi(player, 3, 0, 0, 0, 0, 0);
        if( spell_fizzled != 1 ){
            instance->info_slot = get_id(player, card);
        }
    }
    else if( event == EVENT_REVOLVE_ACTIVATION_FROM_HAND ){
        //put_into_play(player, card);
        //life[HUMAN] = 
        //hand_count[player]--;
    }
    else if ( event == EVENT_CAN_UNMORPH && has_mana_multi(player, colorless, black, blue, green, red, white) ){
        return 1;
    }
    else if( event == EVENT_UNMORPH ){
        charge_mana_multi(player, colorless, black, blue, green, red, white);
        //if( spell_fizzled != 1 ){
        //    instance->info_slot = 2001;
        //}
    }
    return 0;
}

int manland_shared(int player, int card, event_t event, int colorless, int black, int blue, int green, int red, int white){
    card_instance_t *instance = get_card_instance(player, card);
    
    if(event == EVENT_CAN_ACTIVATE ){
        if( has_mana_multi(player, colorless, black, blue, green, red, white) ){
            return 1;
        }
        else if( ! ( is_tapped(player, card) || is_animated_and_sick(player, card ) ) ){
            return 1;
        }
        return 0;
    }
    else if(event == EVENT_ACTIVATE ){
        int choice = 0;
        if( has_mana_multi(player, colorless, black, blue, green, red, white) && instance->targets[0].player != 1 && ! paying_mana() ){
            if( ! ( is_tapped(player, card) || is_animated_and_sick(player, card ) ) ){
                char buffer[50];
                sprintf(buffer, " Generate Mana\n Become a dude\n Cancel" );
                choice = do_dialog(player, player, card, -1, -1, buffer, 1);
            }
            else{
                choice = 1;
            }
        }
        if( choice == 1 ){
            instance->targets[0].player = 1; // disable this until mana is paid
            charge_mana_multi(player, colorless, black, blue, green, red, white);
            instance->targets[0].player = 0;
            if( spell_fizzled != 1  ){
                instance->info_slot = 1;
                return 0;
            }
        }
        else if(choice == 2){
            spell_fizzled = 1;
        }
        else{
            return mana_producer(player, card, event);
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){ 
        card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card );
        if( parent->info_slot == 1 ){
            parent->info_slot = 2;
        }
    }
    if( spell_fizzled != 1 ){
        return mana_producer(player, card, event);
    }
    return 0;
}

int manland_animated(int player, int card, event_t event, int colorless, int black, int blue, int green, int red, int white, const char * creature){
    card_instance_t *instance = get_card_instance(player, card);
    if( eot_trigger(player, card, event ) ){
        instance->info_slot = 0;
        int id = get_internal_card_id_from_csv_id( get_id_by_name(creature) ); 
        instance->internal_card_id = id;
    }
    else if( event == EVENT_SET_COLOR && affect_me(player, card) ){
        event_result = cards_data[ instance->internal_card_id ].color ;
     }
    return manland_shared(player, card, event, colorless, black, blue, green, red, white);
}

int manland_normal(int player, int card, event_t event, int colorless, int black, int blue, int green, int red, int white, const char * creature){
    card_instance_t *instance = get_card_instance(player, card);
    int result = manland_shared(player, card, event, colorless, black, blue, green, red, white);
    
    if( instance->info_slot == 2 ){
        int id = get_internal_card_id_from_csv_id( get_id_by_name(creature) ); 
        instance->internal_card_id = id;
    }

    if(event == EVENT_RESOLVE_ACTIVATION ){ 
        card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card );
        if( parent->info_slot == 1 ){
            parent->info_slot = 2;
        }
    }
    
    if( instance->info_slot == 2 && eot_trigger(player, card, event ) ){
        instance->info_slot = 0;
    }
    
    return result;
}

int mana_producer(int player, int card, event_t event){
    if( event == EVENT_RESOLVE_SPELL ){
        return 0;
    }
    return mana_producer_tapped(player, card, event);   
}

int cannot_be_countered(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    if( event == EVENT_CAST_SPELL && affect_me(player, card) ){
        instance->state |= STATE_CANNOT_TARGET;
    }
    else if( comes_into_play(player, card, event) == 1 ){
        instance->state &= ~STATE_CANNOT_TARGET;
    }
    return 0;
}

int is_colorless(int player, int card){
    if( get_color(player, card) < 2 ){
        return 1;
    }
    return 0;
}

int is_target(int player, int card){
    int p;
    int i;
    for( p = 0; p < 2; p++){
        int count = 0;
        while(count < active_cards_count[p]){
            card_instance_t *this_instance = get_card_instance(p, count);
            for(i=0;i<this_instance->number_of_targets;i++){
                if( this_instance->targets[i].player == player && this_instance->targets[i].card == card ){
                   return 1; 
                }
            }
            count++;
        }
    }
    return 0;
}

/* This is just an approximation */
int troll_shroud(int player, int card){
    int p = opp;
    int i;
    int count = 0;
    while(count < active_cards_count[p]){
        card_instance_t *this_instance = get_card_instance(p, count);
        for(i=0;i<this_instance->number_of_targets;i++){
            if( this_instance->targets[i].player == player && this_instance->targets[i].card == card ){
                this_instance->targets[i].player =-1;        
                this_instance->targets[i].card =-1;
            }
        }
        count++;
    }
    return 0;
}

void tax_attack(int player, int card, event_t event){
    // total tax = 2 * propaganda + domain * collective restraint
    //             + 2 * elephant grass!
    int tax = 2* count_cards_by_id( player, get_id_by_name("Propaganda") )
            + count_domain(player, card) * count_cards_by_id( player, get_id_by_name("Collective Restraint") )
            + 2* count_cards_by_id( player, get_id_by_name("Elephant Grass") );
    if( tax == 0 ){ return; }
    
    if( trigger_condition == TRIGGER_DECLARE_ATTACK && current_phase == PHASE_DECLARE_ATTACKERS && current_turn == 1-player){
        if( affect_me( trigger_cause_controller, trigger_cause ) && reason_for_trigger_controller == affected_card_controller  )
        {
            if(event == EVENT_TRIGGER){
                event_result |= 2;
            }
            else if(event == EVENT_RESOLVE_TRIGGER){
                if( has_mana(1-player, COLOR_ANY, tax) ){
                    int choice = do_dialog(1-player, player, card, -1, -1, " Pay to attack\n Don't Pay\n", 0);
                    if( choice == 0 ){
                        charge_mana(1-player, COLOR_COLORLESS, tax);
                        if( spell_fizzled != 1 ){
                            forbid_attack = 0;
                            return;
                        }
                    }
                }    
                forbid_attack = 1;
            }
        }
    }
}

/* This doesn't actually skip the step, it just reduces number of
   draws by 99.  Should be good enough 99& of the time. */
int skip_your_draw_step(int player, event_t event){
    if(event == EVENT_DRAW_PHASE && player==current_turn){
        event_result-=99;
    }
    return 1;
}

